
(defun tan (aa) (/ (sin aa) (cos aa)))
(defun dtr (bb) (/ (* pi bb) 180.0))

(defun c:ddiffuser ()

  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "be")

  (setq dd_oer *error* *error* dd_err)

  (if (null (rest_dp))
    (rest_dp)
  )

  (setq dd_dmd nil)
  
  (setq old_osnap    (getvar "osmode"))
  (setq blipmode_old (getvar "blipmode"))
  (setq pickbox_old  (getvar "pickbox"))
  (setq angbase_old  (getvar "angbase"))
  (setq col_old      (getvar "cecolor"))
  (setq celtype_old  (getvar "celtype"))
  (setq lay_old      (getvar "clayer"))
  (setq plinewid_old (getvar "plinewid"))
  (setq celtype_old  (getvar "celtype"))
  (setvar "plinewid" 0)
  (setvar "angbase"  0)
  (setvar "blipmode" 0)
  (setvar "pickbox"  0)
  (setvar "celtype" "bylayer")
  
  (run_dd)
  
  (unload_dialog dcl_id)
  (setvar "plinewid" plinewid_old)
  (setvar "angbase"  angbase_old)
  (setvar "clayer"   lay_old)
  (setvar "cecolor"  col_old)
  (setvar "celtype"  celtype_old)
  (setvar "osmode"   old_osnap)
  (setvar "blipmode" blipmode_old)
  (setvar "pickbox"   pickbox_old)
  (setq *error* dd_oer)
  (command "_.undo" "end")
  (setvar "cmdecho"  old_cmdecho)
  (princ)
)
;;;=============================run_dt=================================

(defun run_dd ()

  (setq dcl_id (load_dialog "ddiffuser.dcl"))
  (if (not (new_dialog "dd" dcl_id))
    (exit)
  )
  
  (if (null dd_type)
    (setq dd_type "dd_rnd")
  )
  (if (null dd_dif)
    (setq dd_dif "dd_dif1")
  )
  (if (null dd_view)
    (setq dd_view "dd_plv")
  )
  (if (null dd_dd)
    (setq dd_dd "100")
  )
  (if (null dd_sw)
    (setq dd_sw "200")
  )
  (if (null dd_sh)
    (setq dd_sh "200")
  )
  (if (null opt_1)
    (setq opt_1 "1")
  )
  (if (null de_lay)
    (setq de_lay "1")
  )
  (if (null de_pt)
    (setq de_pt "supply")
  )
  (if (null dp_auto)
    (setq dp_auto "1")
  )

  (dd_imgf)
  (mode_dd)

  (setq dd_dd_old dd_dd)
  (setq dd_sw_old dd_sw)
  (setq dd_sh_old dd_sh)
  
  (action_tile "dd_dif1" "(setq dd_dif \"dd_dif1\") (dd_imgf)")
  (action_tile "dd_dif2" "(setq dd_dif \"dd_dif2\") (dd_imgf)")
  (action_tile "dd_dif3" "(setq dd_dif \"dd_dif3\") (dd_imgf)")

  (action_tile "dd_rct" "(setq dd_type \"dd_rct\") (dd_imgf) (mode_dd)")
  (action_tile "dd_rnd" "(setq dd_type \"dd_rnd\") (dd_imgf) (mode_dd)")

  (action_tile "dd_plv" "(setq dd_view \"dd_plv\") (dd_imgf) (mode_dd)")
  (action_tile "dd_frv" "(setq dd_view \"dd_frv\") (dd_imgf) (mode_dd)")

  (action_tile "dd_dd" "(setq dd_dd $value) (setq key_name $key) (check_dd)")
  (action_tile "dd_sw" "(setq dd_sw $value) (setq key_name $key) (check_dd)")
  (action_tile "dd_sh" "(setq dd_sh $value) (setq key_name $key) (check_dd)")

  (action_tile "dd_opt" "(setq opt_1  (get_tile \"dd_opt\")) (dd_imgf)")
  (action_tile "dd_lay" "(setq de_lay (get_tile \"dd_lay\"))")

  (action_tile "dd_pt1" "(setq de_pt \"supply\")  (eval_de) (dd_imgf)")    
  (action_tile "dd_pt2" "(setq de_pt \"exhaust\") (eval_de) (dd_imgf)")

  (set_tile "dd_dd"  dd_dd)
  (set_tile "dd_sw"  dd_sw)
  (set_tile "dd_sh"  dd_sh)
  (set_tile "dd_opt" opt_1)
  (set_tile "dd_lay" de_lay)

  (cond
    ((= de_pt "supply")  (set_tile "dd_pt1" "1"))
    ((= de_pt "exhaust") (set_tile "dd_pt2" "1"))
  )
  
  (cond
    ((= dd_dif "dd_dif1") (set_tile "dd_dif1" "1"))
    ((= dd_dif "dd_dif2") (set_tile "dd_dif2" "1"))
    ((= dd_dif "dd_dif3") (set_tile "dd_dif3" "1"))
  )

  (cond
    ((= dd_view "dd_plv") (set_tile "dd_plv" "1"))
    ((= dd_view "dd_frv") (set_tile "dd_frv" "1"))
  )

  (cond
    ((= dd_type "dd_rct") (set_tile "dd_rct" "1"))
    ((= dd_type "dd_rnd")  (set_tile "dd_rnd" "1"))
  )

  (action_tile "accept" "(done_dialog 1)")
  (action_tile "cancel" "(done_dialog 0)")

  (eval_de)

  (setq dd_what_next (start_dialog))

  (if (= dd_what_next 0) (princ "\nFunction Cancelled!"))

  (if (= dd_what_next 1)
    (cond
      ((= dd_view "dd_plv") (get_dd))
      ((= dd_view "dd_frv") (get_fd))
    )
  )

)
;;;=============================mode_dd===================================

(defun mode_dd ()

  (cond
    ((and (= dd_view "dd_plv")(= dd_type "dd_rct")) (set_tile "dd_wid" " Width =") (mode_tile "dd_sh" 0))
    ((and (= dd_view "dd_plv")(= dd_type "dd_rnd")) (set_tile "dd_wid" " Diff. Size =") (mode_tile "dd_sh" 1))
    ((= dd_view "dd_frv") (set_tile "dd_wid" " Diff. Size =") (mode_tile "dd_sh" 1))
  )
)
;;;=============================check_db===================================

(defun check_dd ()
  
  (if (<= (atof dd_dd) 0)
    (progn
      (alert
        "Improper Duct Size value!
        \nPlease input proper
        \ngreater than 0."
      )
      (setq dd_dd dd_dd_old)
      (set_tile "dd_dd" dd_dd)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof dd_sw) 0)
    (progn
      (alert
        "Improper Diff. Size or Width value!
        \nPlease input proper
        \ngreater than 0."
      )
      (setq dd_sw dd_sw_old)
      (set_tile "dd_sw" dd_sw)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof dd_sh) 0)
    (progn
      (alert
        "Improper Heigth value!
        \nPlease input proper
        \ngreater than 0."
      )
      (setq dd_sh dd_sh_old)
      (set_tile "dd_sh" dd_sh)
      (mode_tile key_name 2)
    )
  )
)
;;;=============================get_dd===================================

(defun get_dd ()

  (check_eval)
  
  (setq dd_dia (atof dd_dd)
        dd_s1  (atof dd_sw)
        dd_s2  (atof dd_sh)
  )

  (setq dd_ip (getpoint "\nInsertion point :"))

  (cond
    ((= dd_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= dd_ip nil)
     (setq dd_br1 (ssget dd_ip))

     (cond
       ((and (/= dd_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dd_br1 0) (list "hvac_duct")))))
	(get_base)
	(cond
          ((= dd_type "dd_rct")
           (dd_ard)
          )
          ((= dd_type "dd_rnd")
           (dd_acd)
          )
        )
       )
       ((and (/= dd_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dd_br1 0) (list "hvac_end")))))
	(get_end_base)
	(cond
          ((= dd_type "dd_rct")
	   (setq dd_dmd T)
           (dd_ard)
          )
          ((= dd_type "dd_rnd")
	   (setq dd_dmd T)
           (dd_acd)
          )
        )
       )
       (T
	(cond
          ((= dd_type "dd_rct")
	   (princ "\nDirection of Duct :")
           (rct_draw)
          )
          ((= dd_type "dd_rnd")
	   (princ "\nDirection of Duct :")
           (rnd_draw)
          )
        )
       )
     )
    )
  )
)
  
;;;=============================rct_draw===================================

(defun rct_draw ()

  (setq dd_p1 (polar dd_ip (dtr 90)  (/ dd_s2 2)))
  (setq dd_p2 (polar dd_p1 (dtr 0)   (/ dd_s1 2)))
  (setq dd_p3 (polar dd_p2 (dtr 270) dd_s2))
  (setq dd_p4 (polar dd_p3 (dtr 180) dd_s1))
  (setq dd_p5 (polar dd_p4 (dtr 90)  dd_s2))
  (setq dd_an (angle dd_ip dd_p2))
  
  (setq dd_ds (* dd_s1 0.2))
  (if (/= dd_s1 dd_s2)
    (setq dd_ds (* (min dd_s1 dd_s2) 0.2))
  )

  (setvar "osmode" 0)

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (setq dd_pc (polar dd_ip dd_an (/ dd_dia 2)))
  (command "_.circle" dd_ip dd_pc)
  (setq dd_frm (list (entlast)))
  
  (command "_.pline" dd_p2 dd_p3 dd_p4 dd_p5 "c")
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (setq dd_frs (entlast))
  
  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p6  (polar dd_p2 dd_an dd_ds))
     (setq dd_p7  (polar dd_p6 dd_an (* dd_ds 4)))
     (setq dd_p8  (polar dd_p7 dd_an (* dd_ds 2)))
     (setq dd_p9  (polar dd_p7 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p10 (polar dd_p7 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p11 (polar dd_p6 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.rotate" (entlast) "" dd_p11 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )     
     )
    )    
    ((= dd_dif "dd_dif2")
     (setq dd_p6  (polar dd_p2  dd_an dd_ds))
     (setq dd_p7  (polar dd_p6  dd_an dd_ds))
     (setq dd_p8  (polar dd_p7  dd_an (/ dd_ds 2)))
     (setq dd_p9  (polar dd_p8  dd_an dd_ds))
     (setq dd_p10 (polar dd_p9  dd_an (/ dd_ds 2)))
     (setq dd_p11 (polar dd_p10 dd_an dd_ds))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p8  (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p9  (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )
       ((= de_pt "exhaust")
	(command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )     
     )
    ) 
    ((= dd_dif "dd_dif3")
     (setq dd_p6  (polar dd_ip  (dtr 0)   (+ (/ dd_s1 2) (* dd_ds 1.25))))
     (setq dd_p7  (polar dd_p6  (dtr 90)  (/ dd_s1 2)))
     (setq dd_p8  (polar dd_p6  (dtr 270) (/ dd_s1 2)))
     (setq dd_p9  (polar dd_p6  (dtr 0)   (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p7 dd_p8 dd_p9 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p7  (polar dd_p9 (dtr 90)  (/ dd_s1 2)))
	(setq dd_p8  (polar dd_p9 (dtr 270) (/ dd_s1 2)))
	(command "_.pline" dd_p7 dd_p8 dd_p6 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
  )

  (while (setq dd_frs (entnext dd_frs))(setq dd_frm (append dd_frm (list dd_frs))))
  
  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq dd_pc1 (polar dd_ip (dtr 0)   (+ (/ dd_s1 2) (* dd_ds 1.25))))
      (setq dd_pc2 (polar dd_ip (dtr 90)  (+ (/ dd_s2 2) (* dd_ds 1.25))))
      (setq dd_pc3 (polar dd_ip (dtr 180) (+ (/ dd_s1 2) (* dd_ds 1.25))))
      (setq dd_pc4 (polar dd_ip (dtr 270) (+ (/ dd_s2 2) (* dd_ds 1.25))))
      (command "_.line" dd_pc1 dd_pc3 "")
      (setq dd_frm (append dd_frm (list (entlast))))
      (command "_.line" dd_pc2 dd_pc4 "")
      (setq dd_frm (append dd_frm (list (entlast))))
    )
  )

  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (command "_.group" "c" "*" "" ss "")

  (setvar "osmode" old_osnap)

  (command "_.rotate" ss "" dd_ip pause) 
)
;;;=============================rnd_draw===================================

(defun rnd_draw ()

  (setq dd_ds (* dd_s1 0.2))
  (setq dd_p1 (polar dd_ip (dtr 90) (/ dd_s1 2)))
  (setq dd_p2 (polar dd_ip (dtr 45) (/ dd_s1 2)))
  (setq dd_an (angle dd_ip dd_p2))

  (setvar "osmode" 0)

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (setq dd_pc (polar dd_ip dd_an (/ dd_dia 2)))
  (command "_.circle" dd_ip dd_pc)
  (setq dd_frm (list (entlast)))

  (command "_.circle" dd_ip dd_p2)
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (setq dd_frs (entlast))

  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p6  (polar dd_p2 dd_an dd_ds))
     (setq dd_p7  (polar dd_p6 dd_an (* dd_ds 4)))
     (setq dd_p8  (polar dd_p7 dd_an (* dd_ds 2)))
     (setq dd_p9  (polar dd_p7 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p10 (polar dd_p7 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p11 (polar dd_p6 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.rotate" (entlast) "" dd_p11 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
    ((= dd_dif "dd_dif2")
     (setq dd_p6  (polar dd_p2  dd_an dd_ds))
     (setq dd_p7  (polar dd_p6  dd_an dd_ds))
     (setq dd_p8  (polar dd_p7  dd_an (/ dd_ds 2)))
     (setq dd_p9  (polar dd_p8  dd_an dd_ds))
     (setq dd_p10 (polar dd_p9  dd_an (/ dd_ds 2)))
     (setq dd_p11 (polar dd_p10 dd_an dd_ds))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p8  (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p9  (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
    ((= dd_dif "dd_dif3")
     (setq dd_p6  (polar dd_ip (dtr 0)   (* (/ dd_s1 2) 1.5)))
     (setq dd_p7  (polar dd_p6 (dtr 90)  (/ dd_s1 2)))
     (setq dd_p8  (polar dd_p6 (dtr 270) (/ dd_s1 2)))
     (setq dd_p9  (polar dd_p6 (dtr 0)   (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p7 dd_p8 dd_p9 "c")
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p7  (polar dd_p9 (dtr 90)  (/ dd_s1 2)))
	(setq dd_p8  (polar dd_p9 (dtr 270) (/ dd_s1 2)))
	(command "_.pline" dd_p7 dd_p8 dd_p6 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
  )

  (while (setq dd_frs (entnext dd_frs))(setq dd_frm (append dd_frm (list dd_frs))))

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq dd_pc1 (polar dd_ip (dtr 0)   (* (/ dd_s1 2) 1.5)))
      (setq dd_pc2 (polar dd_ip (dtr 90)  (* (/ dd_s1 2) 1.5)))
      (setq dd_pc3 (polar dd_ip (dtr 180) (* (/ dd_s1 2) 1.5)))
      (setq dd_pc4 (polar dd_ip (dtr 270) (* (/ dd_s1 2) 1.5)))
      (command "_.line" dd_pc1 dd_pc3 "")
      (setq dd_frm (append dd_frm (list (entlast))))
      (command "_.line" dd_pc2 dd_pc4 "")
      (setq dd_frm (append dd_frm (list (entlast))))
    )
  )
  
  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (setvar "osmode" old_osnap)

  (command "_.group" "c" "*" "" ss "")

  (command "_.rotate" ss "" dd_ip pause) 
)
;;;=============================dd_ard===================================

(defun dd_ard ()

  (setq dd_ip (polar dd_ip dp_mda (/ dp_mds 2)))

  (cond
    ((and (= dd_dmd T) (= dd_dia dp_mds))
     (setq dd_ip dp_e1)
     (setq dd_del (ssname dd_br1 0))
     (setq dd_dlm (entdel dd_del))
    )
    ((and (= dd_dmd T) (/= dd_dia dp_mds))
     (setq dd_ip (polar dp_e1 dp_mda (/ dp_mds 2)))
    )
  )

  (setq dd_p1 (polar dd_ip (+ dp_mda pi)  (/ dd_s2 2)))
  (setq dd_p2 (polar dd_p1 (+ dp_mda (/ pi 2))   (/ dd_s1 2)))
  (setq dd_p3 (polar dd_p2 dp_mda dd_s2))
  (setq dd_p4 (polar dd_p3 (- dp_mda (/ pi 2)) dd_s1))
  (setq dd_p5 (polar dd_p4 (+ dp_mda pi)  dd_s2))
  (setq dd_an (angle dd_ip dd_p2))
  
  (setq dd_ds (* dd_s1 0.2))
  (if (/= dd_s1 dd_s2)
    (setq dd_ds (* (min dd_s1 dd_s2) 0.2))
  )

  (setvar "osmode" 0)

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (setq dd_pc (polar dd_ip dd_an (/ dd_dia 2)))
  (command "_.circle" dd_ip dd_pc)
  (setq dd_frm (list (entlast)))
  
  (command "_.pline" dd_p2 dd_p3 dd_p4 dd_p5 "c")
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (setq dd_frs (entlast))
  
  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p6  (polar dd_p2 dd_an dd_ds))
     (setq dd_p7  (polar dd_p6 dd_an (* dd_ds 4)))
     (setq dd_p8  (polar dd_p7 dd_an (* dd_ds 2)))
     (setq dd_p9  (polar dd_p7 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p10 (polar dd_p7 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p11 (polar dd_p6 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.rotate" (entlast) "" dd_p11 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )     
     )
    )    
    ((= dd_dif "dd_dif2")
     (setq dd_p6  (polar dd_p2  dd_an dd_ds))
     (setq dd_p7  (polar dd_p6  dd_an dd_ds))
     (setq dd_p8  (polar dd_p7  dd_an (/ dd_ds 2)))
     (setq dd_p9  (polar dd_p8  dd_an dd_ds))
     (setq dd_p10 (polar dd_p9  dd_an (/ dd_ds 2)))
     (setq dd_p11 (polar dd_p10 dd_an dd_ds))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p8  (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p9  (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )
       ((= de_pt "exhaust")
	(command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
	(command "_.mirror" (entlast) "" dd_ip dd_p1 "n")
	(command "_.array" (entlast) "" "p" dd_ip 2 360 "y")
       )     
     )
    )
    ((= dd_dif "dd_dif3")
     (setq dd_p6  (polar dd_ip (+ dp_mda (/ pi 2)) (+ (/ dd_s1 2) (* dd_ds 1.25))))
     (setq dd_p7  (polar dd_p6 (+ dp_mda pi)  (/ dd_s1 2)))
     (setq dd_p8  (polar dd_p6 dp_mda (/ dd_s1 2)))
     (setq dd_p9  (polar dd_p6 (+ dp_mda (/ pi 2))   (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p7 dd_p8 dd_p9 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p7  (polar dd_p9 (+ dp_mda pi)  (/ dd_s1 2)))
	(setq dd_p8  (polar dd_p9 dp_mda (/ dd_s1 2)))
	(command "_.pline" dd_p7 dd_p8 dd_p6 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
  )

  (while (setq dd_frs (entnext dd_frs))(setq dd_frm (append dd_frm (list dd_frs))))
  
  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq dd_pc1 (polar dd_ip (+ dp_mda (/ pi 2))   (+ (/ dd_s1 2) (* dd_ds 1.25))))
      (setq dd_pc2 (polar dd_ip (+ dp_mda pi)  (+ (/ dd_s2 2) (* dd_ds 1.25))))
      (setq dd_pc3 (polar dd_ip (- dp_mda (/ pi 2)) (+ (/ dd_s1 2) (* dd_ds 1.25))))
      (setq dd_pc4 (polar dd_ip dp_mda (+ (/ dd_s2 2) (* dd_ds 1.25))))
      (command "_.line" dd_pc1 dd_pc3 "")
      (setq dd_frm (append dd_frm (list (entlast))))
      (command "_.line" dd_pc2 dd_pc4 "")
      (setq dd_frm (append dd_frm (list (entlast))))
    )
  )

  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (command "_.group" "c" "*" "" ss "")
)
;;;=============================dd_acd===================================

(defun dd_acd ()

  (setq dd_ip (polar dd_ip dp_mda (/ dp_mds 2)))

  (cond
    ((and (= dd_dmd T) (= dd_dia dp_mds))
     (setq dd_ip dp_e1)
     (setq dd_del (ssname dd_br1 0))
     (setq dd_dlm (entdel dd_del))
    )
    ((and (= dd_dmd T) (/= dd_dia dp_mds))
     (setq dd_ip (polar dp_e1 dp_mda (/ dp_mds 2)))
    )
  )

  (setq dd_ds (* dd_s1 0.2))
  (setq dd_p1 (polar dd_ip (+ dp_mda pi)  (/ dd_s1 2)))
  (setq dd_p2 (polar dd_ip (+ dp_mda (* pi 0.75)) (/ dd_s1 2)))
  (setq dd_an (angle dd_ip dd_p2))

  (setvar "osmode" 0)

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (setq dd_pc (polar dd_ip dd_an (/ dd_dia 2)))
  (command "_.circle" dd_ip dd_pc)
  (setq dd_frm (list (entlast)))

  (command "_.circle" dd_ip dd_p2)
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (setq dd_frs (entlast))

  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p6  (polar dd_p2 dd_an dd_ds))
     (setq dd_p7  (polar dd_p6 dd_an (* dd_ds 4)))
     (setq dd_p8  (polar dd_p7 dd_an (* dd_ds 2)))
     (setq dd_p9  (polar dd_p7 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p10 (polar dd_p7 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p11 (polar dd_p6 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p6 dd_p7 dd_p10 dd_p8 dd_p9 dd_p7 "")
	(command "_.rotate" (entlast) "" dd_p11 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
    ((= dd_dif "dd_dif2")
     (setq dd_p6  (polar dd_p2  dd_an dd_ds))
     (setq dd_p7  (polar dd_p6  dd_an dd_ds))
     (setq dd_p8  (polar dd_p7  dd_an (/ dd_ds 2)))
     (setq dd_p9  (polar dd_p8  dd_an dd_ds))
     (setq dd_p10 (polar dd_p9  dd_an (/ dd_ds 2)))
     (setq dd_p11 (polar dd_p10 dd_an dd_ds))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p8  (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p9  (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(command "_.pline" dd_p6 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
	(command "_.pline" dd_p7 dd_p13 dd_p14 dd_p10 "")
	(command "_.rotate" (entlast) "" dd_p10 180)
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
    ((= dd_dif "dd_dif3")
     (setq dd_p6  (polar dd_ip (+ dp_mda (/ pi 2))   (* (/ dd_s1 2) 1.5)))
     (setq dd_p7  (polar dd_p6 (+ dp_mda pi)  (/ dd_s1 2)))
     (setq dd_p8  (polar dd_p6 dp_mda (/ dd_s1 2)))
     (setq dd_p9  (polar dd_p6 (+ dp_mda (/ pi 2))   (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p7 dd_p8 dd_p9 "c")
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )
       ((= de_pt "exhaust")
	(setq dd_p7  (polar dd_p9 (+ dp_mda pi)  (/ dd_s1 2)))
	(setq dd_p8  (polar dd_p9 dp_mda (/ dd_s1 2)))
	(command "_.pline" dd_p7 dd_p8 dd_p6 "c")
	(command "_.array" (entlast) "" "p" dd_ip 4 360 "y")
       )     
     )
    )
  )

  (while (setq dd_frs (entnext dd_frs))(setq dd_frm (append dd_frm (list dd_frs))))

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq dd_pc1 (polar dd_ip (+ dp_mda (/ pi 2))   (* (/ dd_s1 2) 1.5)))
      (setq dd_pc2 (polar dd_ip (+ dp_mda pi)  (* (/ dd_s1 2) 1.5)))
      (setq dd_pc3 (polar dd_ip (- dp_mda (/ pi 2)) (* (/ dd_s1 2) 1.5)))
      (setq dd_pc4 (polar dd_ip dp_mda (* (/ dd_s1 2) 1.5)))
      (command "_.line" dd_pc1 dd_pc3 "")
      (setq dd_frm (append dd_frm (list (entlast))))
      (command "_.line" dd_pc2 dd_pc4 "")
      (setq dd_frm (append dd_frm (list (entlast))))
    )
  )
  
  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (command "_.group" "c" "*" "" ss "")
)
;;;=============================get_fd===================================

(defun get_fd ()

  (check_eval)
  
  (setq dd_dia (atof dd_dd)
        dd_s1  (atof dd_sw)
        dd_s2  (atof dd_sh)
  )

  (setq dd_ip (getpoint "\nInsertion point :"))

  (cond
    ((= dd_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= dd_ip nil)
     (setq dd_br1 (ssget dd_ip))

     (cond
       ((and (/= dd_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dd_br1 0) (list "hvac_duct")))))
	(get_base)
	(dd_afd)
       )
       ((and (/= dd_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dd_br1 0) (list "hvac_end")))))
	(get_end_base)
	(setq dd_dmd T)
	(dd_afd)
       )
       (T
	(princ "\nDirection of Duct :")
	(dd_mfd)
       )
     )
    )
  )
)
;=================================dd_mfd======================================

(defun dd_mfd ()

  (setvar "osmode" 0)

  (setq dd_ds (* dd_s1 0.2))

  (setq dd_p1 (polar dd_ip 0  (/ dd_dia 2)))
  (setq dd_p2 (polar dd_ip pi (/ dd_dia 2)))
  (setq dd_p3 (polar dd_p1 (/ pi 2) (/ dd_dia 2)))
  (setq dd_p4 (polar dd_p2 (/ pi 2) (/ dd_dia 2)))
  (setq dd_p9 (polar dd_ip (/ pi 2) (+ (/ dd_dia 2) (/ dd_s1 4))))
  (setq dd_p7 (polar dd_p9 0  (/ dd_s1 2)))
  (setq dd_p8 (polar dd_p9 pi (/ dd_s1 2)))
  (setq dd_p5 (polar dd_p7 (* pi 1.5) (/ dd_s1 4)))
  (setq dd_p6 (polar dd_p8 (* pi 1.5) (/ dd_s1 4)))
  
  (setq dd_p10 (polar dd_p9 (/ pi 2) dd_ds))
  (setq dd_an (angle dd_ip dd_p9))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (command "_.pline" dd_p5 dd_p7 dd_p8 dd_p6 "c")
  (setq dd_frm (list (entlast)))
  
  (command "_.pline" dd_p3 dd_p1 dd_p2 dd_p4 "")
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p11 (polar dd_p10 dd_an (* dd_ds 4)))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p11 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p11 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p10 dd_p11 dd_p13 dd_p12 dd_p14 dd_p11 "")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p10 dd_p11 dd_p13 dd_p12 dd_p14 dd_p11 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    )    
    ((= dd_dif "dd_dif2")
     (setq dd_p11 (polar dd_p10 dd_an (* dd_ds 4)))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p10 dd_an dd_ds))
     (setq dd_p14 (polar dd_p13 dd_an (/ dd_ds 2)))
     (setq dd_p16 (polar dd_p14 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p17 (polar dd_p14 dd_an dd_ds))
     (setq dd_p18 (polar dd_p17 (- dd_an (/ pi 2)) dd_ds))
     (setq dd_p19 (polar dd_p17 dd_an (/ dd_ds 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p10 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.pline" dd_p13 dd_p16 dd_p18 dd_p19 "")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p10 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.pline" dd_p13 dd_p16 dd_p18 dd_p19 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    ) 
    ((= dd_dif "dd_dif3")
     (setq dd_p11 (polar dd_p10 (+ dd_an (/ pi 2)) (/ dd_s1 2)))
     (setq dd_p12 (polar dd_p10 (- dd_an (/ pi 2)) (/ dd_s1 2)))
     (setq dd_p13 (polar dd_p10 dd_an (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p11 dd_p12 dd_p13 "c")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (/ (distance dd_p10 dd_p13) 2)))
	(command "_.pline" dd_p11 dd_p12 dd_p13 "c")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    )
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" dd_ip dd_p9 "")
      (setq dd_frm (append dd_frm (list (entlast))))
    )
  )

  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (setvar "osmode" old_osnap)

  (command "_.group" "c" "*" "" ss "")

  (command "_.rotate" ss "" dd_ip pause) 
)
;=================================dd_afd======================================

(defun dd_afd ()

  (if (= dd_dmd T)
    (setq dd_ip dp_e1)
  )

  (setvar "osmode" 0)

  (setq dd_ds (* dd_s1 0.2))

  (setq dd_p1 (polar dd_ip (+ dp_mda (/ pi 2)) (/ dd_dia 2)))
  (setq dd_p2 (polar dd_ip (- dp_mda (/ pi 2)) (/ dd_dia 2)))
  (setq dd_p3 (polar dd_p1 (+ dp_mda pi) (/ dd_dia 2)))
  (setq dd_p4 (polar dd_p2 (+ dp_mda pi) (/ dd_dia 2)))
  (setq dd_p9 (polar dd_ip (+ dp_mda pi) (+ (/ dd_dia 2) (/ dd_s1 4))))
  (setq dd_p7 (polar dd_p9 (+ dp_mda (/ pi 2))  (/ dd_s1 2)))
  (setq dd_p8 (polar dd_p9 (- dp_mda (/ pi 2)) (/ dd_s1 2)))
  (setq dd_p5 (polar dd_p7 dp_mda (/ dd_s1 4)))
  (setq dd_p6 (polar dd_p8 dp_mda (/ dd_s1 4)))
  
  (setq dd_p10 (polar dd_p9 (+ dp_mda pi) dd_ds))
  (setq dd_an (angle dd_ip dd_p9))

  (setq dd_b1 (ssget dd_p1))
  (setq dd_b2 (ssget dd_p2))

  (if (and (= d_type "RND_DUCT") (/= dd_dmd T) (/= dd_b1 nil) (/= dd_b2 nil) (or (equal dp_mds dd_dia 1) (> dp_mds dd_dia)))
    (command "_.break" dd_p1 dd_p2)
  )

  (setq dd_p20 (polar dd_ip dp_mda (/ dp_mds 2)))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.pline" dd_p5 dd_p7 dd_p8 dd_p6 "c")
  (setq dd_frm (list (entlast)))

  (cond
    ((and (= d_type "RND_DUCT") (/= dd_dmd T) (not (equal dp_mds dd_dia 1)) (> dp_mds dd_dia))
     (setq dd_ac  (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt dd_dia 2.0)))))
     (setq dd_p21 (polar dd_ip dp_mda (/ dd_ac 2.0)))
     (command "_.arc" dd_p1 dd_p21 dd_p2)
     (setq dd_frm (append dd_frm (list (entlast))))
    )
    ((and (= d_type "RND_DUCT") (/= dd_dmd T) (equal dp_mds dd_dia 1))
     (setq dd_p20 (polar dd_ip dp_mda (/ dp_mds 2)))
     (command "_.pline" dd_p1 dd_p20 dd_p2 "")
     (setq dd_frm (append dd_frm (list (entlast))))
    )
  )

  (command "_.line" dd_p1 dd_p3 "")
  (setq dd_frm (append dd_frm (list (entlast))))

  (command "_.line" dd_p2 dd_p4 "")
  (setq dd_frm (append dd_frm (list (entlast))))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" ac_lyr "s" ac_lyr "")
      (command "_.color" ac_clr)
    )
  )

  (cond
    ((= dd_dif "dd_dif1")
     (setq dd_p11 (polar dd_p10 dd_an (* dd_ds 4)))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p11 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p14 (polar dd_p11 (- dd_an (/ pi 2)) dd_ds))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p10 dd_p11 dd_p13 dd_p12 dd_p14 dd_p11 "")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p10 dd_p11 dd_p13 dd_p12 dd_p14 dd_p11 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    )    
    ((= dd_dif "dd_dif2")
     (setq dd_p11 (polar dd_p10 dd_an (* dd_ds 4)))
     (setq dd_p12 (polar dd_p11 dd_an (* dd_ds 2)))
     (setq dd_p13 (polar dd_p10 dd_an dd_ds))
     (setq dd_p14 (polar dd_p13 dd_an (/ dd_ds 2)))
     (setq dd_p16 (polar dd_p14 (+ dd_an (/ pi 2)) dd_ds))
     (setq dd_p17 (polar dd_p14 dd_an dd_ds))
     (setq dd_p18 (polar dd_p17 (- dd_an (/ pi 2)) dd_ds))
     (setq dd_p19 (polar dd_p17 dd_an (/ dd_ds 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p10 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.pline" dd_p13 dd_p16 dd_p18 dd_p19 "")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (* dd_ds 3)))
	(command "_.pline" dd_p10 dd_p11 "w" (* dd_ds 2) 0 dd_p12 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
	(command "_.pline" dd_p13 dd_p16 dd_p18 dd_p19 "")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    ) 
    ((= dd_dif "dd_dif3")
     (setq dd_p11 (polar dd_p10 (+ dd_an (/ pi 2)) (/ dd_s1 2)))
     (setq dd_p12 (polar dd_p10 (- dd_an (/ pi 2)) (/ dd_s1 2)))
     (setq dd_p13 (polar dd_p10 dd_an (/ dd_s1 2)))
     (cond
       ((= de_pt "supply")
        (command "_.pline" dd_p11 dd_p12 dd_p13 "c")
	(setq dd_frm (append dd_frm (list (entlast))))
       )
       ((= de_pt "exhaust")
	(setq dd_p15 (polar dd_p10 dd_an (/ (distance dd_p10 dd_p13) 2)))
	(command "_.pline" dd_p11 dd_p12 dd_p13 "c")
	(command "_.rotate" (entlast) "" dd_p15 180)
	(setq dd_frm (append dd_frm (list (entlast))))
       )     
     )
    )
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (if (and (= d_type "RND_DUCT") (/= dd_dmd T))
	(progn
	  (command "_.line" dd_p20 dd_p9 "")
	  (setq dd_frm (append dd_frm (list (entlast))))
	)
	(progn
	  (command "_.line" dd_ip dd_p9 "")
	  (setq dd_frm (append dd_frm (list (entlast))))
	)
      )
    )
  )

  (setq lstn (length dd_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dd_frm) ss)
  )

  (command "_.group" "c" "*" "" ss "")
)
;================================get_base=====================================

(defun get_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
    )
  )
)
;================================get_end_base=====================================

(defun get_end_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
  )
)
;;;=============================dd_imgf===================================

(defun dd_imgf ()
    (cond
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_r1")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_r2")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_r3")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_r4")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_r5")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_r6")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_r7")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_r8")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_r9")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_r10")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_r11")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rct") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_r12")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_p1")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_p2")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_p3")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_p4")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_p5")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_p6")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_p7")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_p8")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_p9")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_p10")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_p11")
      )
      ((and (= dd_view "dd_plv") (= dd_type "dd_rnd") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_p12")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_f1")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif1") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_f2")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_f3")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif1") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_f4")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_f5")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif2") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_f6")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_f7")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif2") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_f8")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "1"))
         (setq slide "dd_f9")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif3") (= de_pt "supply") (= opt_1 "0"))
         (setq slide "dd_f10")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "1"))
         (setq slide "dd_f11")
      )
      ((and (= dd_view "dd_frv") (= dd_dif "dd_dif3") (= de_pt "exhaust") (= opt_1 "0"))
         (setq slide "dd_f12")
      )
    )
  (setq dd_slide (strcat "dd_view(" slide ")" ))
  (setq xdim (dimx_tile "dd_image"))
  (setq ydim (dimy_tile "dd_image"))
  (start_image "dd_image")
  (fill_image 0 0 xdim ydim 0)
  (slide_image 0 0 xdim ydim dd_slide)
  (end_image)
)
;================================eval_de=====================================

(defun eval_de ()
  (cond
    ((= de_pt "supply")
       (progn
         (setq vp_lyr sup_lyr)
         (setq cl_lyr scl_lyr)
         (setq tl_lyr stl_lyr)
	 (setq ac_lyr sac_lyr)
         (setq vp_clr sup_clr)
         (setq cl_clr scl_clr)
         (setq tl_clr stl_clr)
	 (setq ac_clr sac_clr)
       )
    )
    ((= de_pt "exhaust")
       (progn
         (setq vp_lyr exh_lyr)
         (setq cl_lyr ecl_lyr)
         (setq tl_lyr etl_lyr)
	 (setq ac_lyr eac_lyr)
         (setq vp_clr exh_clr)
         (setq cl_clr ecl_clr)
         (setq tl_clr etl_clr)
	 (setq ac_clr eac_clr)
       )
    )
  )
)
;==================================check_eval=====================================

(defun check_eval ()

  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" vp_lyr))) 0)
      (progn
        (setq vp_st  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rh  (assoc 70 vp_st))
        (setq vp_nch (cons 70 0))
        (setq vp_nst (subst vp_nch vp_rh vp_st))
        (entmod vp_nst)
      )
    )
  )
  
  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" vp_lyr))) 7)
      (progn
        (setq vp_ft  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rf  (assoc 62 vp_ft))
        (setq vp_ncf (cons 62 7))
        (setq vp_fst (subst vp_ncf vp_rf vp_ft))
        (entmod vp_fst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" cl_lyr))) 0)
      (progn
        (setq cl_st  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rh  (assoc 70 cl_st))
        (setq cl_nch (cons 70 0))
        (setq cl_nst (subst cl_nch cl_rh cl_st))
        (entmod cl_nst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" cl_lyr))) 7)
      (progn
        (setq cl_ft  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rf  (assoc 62 cl_ft))
        (setq cl_ncf (cons 62 7))
        (setq cl_fst (subst cl_ncf cl_rf cl_ft))
        (entmod cl_fst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" tl_lyr))) 0)
      (progn
        (setq tl_st  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rh  (assoc 70 tl_st))
        (setq tl_nch (cons 70 0))
        (setq tl_nst (subst tl_nch tl_rh tl_st))
        (entmod tl_nst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" tl_lyr))) 7)
      (progn
        (setq tl_ft  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rf  (assoc 62 tl_ft))
        (setq tl_ncf (cons 62 7))
        (setq tl_fst (subst tl_ncf tl_rf tl_ft))
        (entmod tl_fst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" ac_lyr))) 0)
      (progn
        (setq ac_st  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rh  (assoc 70 ac_st))
        (setq ac_nch (cons 70 0))
        (setq ac_nst (subst ac_nch ac_rh ac_st))
        (entmod ac_nst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" ac_lyr))) 7)
      (progn
        (setq ac_ft  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rf  (assoc 62 ac_ft))
        (setq ac_ncf (cons 62 7))
        (setq ac_fst (subst ac_ncf ac_rf ac_ft))
        (entmod ac_fst)
      )
    )
  )
)
;;;=============================rest_de===================================

(Defun rest_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (if (= nil (findfile de_cfg))
    (progn
      (princ (strcat "\nCreating default layer settings..." "delbow.cfg\n"))
      (setq de_fh (open de_cfg "w"))
      (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
      (write-line "Supply Air layer:" de_fh)
      (write-line "HVAC-SP" de_fh)
      (write-line "Supply Air layer color:" de_fh)
      (write-line "4" de_fh)
      (write-line "Supply Air Center Line layer:" de_fh)
      (write-line "HVAC-SP-CL" de_fh)
      (write-line "Supply Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Supply Air Text Line layer:" de_fh)
      (write-line "HVAC-SP-TL" de_fh)
      (write-line "Supply Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Supply Air Accessories layer:" de_fh)
      (write-line "HVAC-EX-AC" de_fh)
      (write-line "Supply Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "Exhaust Air layer:" de_fh)
      (write-line "HVAC-VT" de_fh)
      (write-line "Exhaust Air layer color:" de_fh)
      (write-line "6" de_fh)
      (write-line "Exhaust Air Center Line layer:" de_fh)
      (write-line "HVAC-VT-CL" de_fh)
      (write-line "Exhaust Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Exhaust Air Text Line layer:" de_fh)
      (write-line "HVAC-VT-TL" de_fh)
      (write-line "Exhaust Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Exhaust Air Accessories layer:" de_fh)
      (write-line "HVAC-EX-AC" de_fh)
      (write-line "Exhaust Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "End of File..." de_fh) 
      (close de_fh)
    )
  )
  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================*error*======================================

(defun dd_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if dd_oer
    (setq *error* dd_oer)
  )
  (if plinewid_old (setvar "plinewid" plinewid_old))
  (if old_osnap    (setvar "osmode"   old_osnap))
  (if blipmode_old (setvar "blipmode" blipmode_old))
  (if pickbox_old  (setvar "pickbox"   pickbox_old))
  (if angbase_old  (setvar "angbase"  angbase_old))
  (if lay_old      (setvar "clayer"   lay_old))
  (if col_old      (setvar "cecolor"  col_old))
  (if celtype_old  (setvar "celtype"  celtype_old))
  (command "_.undo" "end")
  (if old_cmdecho  (setvar "cmdecho"  old_cmdecho))
)
    
(princ)
