
(defun c:dpipe (/)

  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "_be")

  (setq dp_oer *error* *error* dp_err)

  (if (null (rest_dp))
    (rest_dp)
  )

  (setq dp_lsl nil)
  (setq dp_ls1 nil)
  (setq dp_ls2 nil)
  (setq dp_ls3 nil)
  (setq dp_pt5 nil)
  (setq db_dls nil)
  (setq db_dle nil)
  (setq db_gbs nil)
  (setq ab_mda nil)
  (setq dp_etd nil)

  (setq old_osnap    (getvar "osmode"))
  (setq blipmode_old (getvar "blipmode"))
  (setq pickbox_old  (getvar "pickbox"))
  (setq angbase_old  (getvar "angbase"))
  (setq col_old      (getvar "cecolor"))
  (setq celtype_old  (getvar "celtype"))
  (setq lay_old      (getvar "clayer"))
  (setq text_old     (getvar "textstyle"))
  (setq plinewid_old (getvar "plinewid"))
  (setvar "plinewid" 0)
  (setvar "angbase"  0)
  (setvar "blipmode" 0)
  (setvar "pickbox"  0)
  (setvar "celtype" "bylayer")

  (run_dp)
    
  (unload_dialog dcl_id)
  (setvar "plinewid"  plinewid_old)
  (setvar "angbase"   angbase_old)
  (setvar "textstyle" text_old)
  (setvar "clayer"    lay_old)
  (setvar "cecolor"   col_old)
  (setvar "celtype"   celtype_old)
  (setvar "osmode"    old_osnap)
  (setvar "blipmode"  blipmode_old)
  (setvar "pickbox"   pickbox_old)
  (setq *error* dp_oer)
  (command "_.undo" "_end")
  (setvar "cmdecho"   old_cmdecho)
  (princ)
)
;;;================================Run_dp=========================================

(defun run_dp ()
  
  (setq dp_what_next 2)
  
  (while (>= dp_what_next 2)
    
    
        (setq dcl_id (load_dialog "dpipe.dcl"))
        (if (not (new_dialog "dp" dcl_id))
            (exit)
        )

        (if (null dp_dia)
	  (setq dp_dia "100")
	)
        (if (null dp_rd)
          (setq dp_rd "1")
	)
        (if (null dp_pcs)
	  (setq dp_pcs "4")
	)
        (if (null opt_1)
	  (setq opt_1 "1")
	)
        (if (null dp_type)
	  (setq dp_type "dp_mitered")
	)
        (if (null de_pt)
	  (setq de_pt "supply")
	)
        (if (null dp_heg)
	  (setq dp_heg "100")
	)
        (if (null dp_text)
	  (setq dp_text "1")
	)
        (if (null de_lay)
	  (setq de_lay "1")
	)
        (if (null dp_end)
	  (setq dp_end "1")
	)
        (if (null dp_txt)
	  (setq dp_txt "200")
	)
        (if (null t_type)
	  (setq t_type "t_txt1")
	)
        (if (null db_len)
          (setq db_len "50")
        )
        (if (null db_tbr)
          (setq db_tbr "1")
        )
        (if (null dp_piece)
	  (setq dp_piece "1")
	)
        (if (null de_polar)
	  (setq de_polar "1")
	)
        (if (null dp_auto)
	  (setq dp_auto "1")
	)

        (dp_img)
        (mode_dp)

        (setq dp_dia_old   dp_dia
	      dp_heg_old   dp_heg
              dp_rd_old    dp_rd
              dp_pcs_old   dp_pcs
	      dp_heg_old   dp_heg
	      dp_txt_old   dp_txt
        )

        (action_tile "dp_mitered" "(setq dp_type \"dp_mitered\") (dp_img) (mode_dp)")    
        (action_tile "dp_radius"  "(setq dp_type \"dp_radius\")  (dp_img) (mode_dp)")

        (action_tile "dp_pt1" "(setq de_pt \"supply\")  (eval_de) (dp_img)")    
        (action_tile "dp_pt2" "(setq de_pt \"exhaust\") (eval_de) (dp_img)")

        (action_tile "dp_dia" "(setq dp_dia (get_tile \"dp_dia\")) (setq key_name $key) (check_dp)")

        (action_tile "dp_heg" "(setq dp_heg (get_tile \"dp_heg\")) (setq key_name $key) (check_dp)")
  
        (action_tile "dp_dis" "(done_dialog 4)")

        (action_tile "dp_ops" "(done_dialog 3)")

        (action_tile "dp_rad" "(done_dialog 7)")

        (action_tile "dp_rd" "(setq dp_rd (get_tile \"dp_rd\")) (setq key_name $key) (check_dp)")
    
        (action_tile "dp_pcs" "(setq dp_pcs (get_tile \"dp_pcs\")) (setq key_name $key) (check_dp)")

        (action_tile "dp_txt"  "(setq dp_txt $value) (setq key_name $key) (check_dp)")
    
        (action_tile "dp_txt1" "(setq t_type \"t_txt1\") (dp_img) (mode_dp)")
    
        (action_tile "dp_txt2" "(setq t_type \"t_txt2\") (dp_img) (mode_dp)")

        (action_tile "dp_opt" "(setq opt_1 (get_tile \"dp_opt\")) (dp_img)")

        (action_tile "dp_text" "(setq dp_text (get_tile \"dp_text\")) (dp_img)")

	(action_tile "dp_lay"  "(setq de_lay (get_tile \"dp_lay\"))")

	(action_tile "dp_end"  "(setq dp_end (get_tile \"dp_end\")) (dp_img)")

        (action_tile "dp_polar" "(setq de_polar (get_tile \"dp_polar\"))")

        (action_tile "dp_piece" "(setq dp_piece (get_tile \"dp_piece\")) (mode_dp)")
  
        (set_tile "dp_dia"   dp_dia)
        (set_tile "dp_rd"    dp_rd)
        (set_tile "dp_pcs"   dp_pcs)
        (set_tile "dp_opt"   opt_1)
        (set_tile "dp_heg"   dp_heg)
        (set_tile "dp_text"  dp_text)
        (set_tile "dp_lay"   de_lay)
        (set_tile "dp_end"   dp_end)
        (set_tile "dp_txt"   dp_txt)
        (set_tile "dp_polar" de_polar)
        (set_tile "dp_piece" dp_piece)

        (cond
	  ((= de_pt "supply")  (set_tile "dp_pt1" "1"))
	  ((= de_pt "exhaust") (set_tile "dp_pt2" "1"))
	)

        (cond
          ((= t_type "t_txt1") (set_tile "dp_txt1" "1"))
          ((= t_type "t_txt2") (set_tile "dp_txt2" "1"))
        )

        (cond
	  ((= dp_type "dp_mitered") (set_tile "dp_mitered" "1"))
	  ((= dp_type "dp_radius")  (set_tile "dp_radius"  "1"))
	)

        (action_tile "accept" "(done_dialog 1)")
        (action_tile "cancel" "(done_dialog 0)")

        (eval_de)

        (setq dp_what_next (start_dialog))

        (if (= dp_what_next 1) (dp_anl))

        (if (= dp_what_next 4) (dp_gds))
    
        (if (= dp_what_next 0) (princ "\nFunction Cancelled!"))

        (if (= dp_what_next 3) (dp_opt))

        (if (= dp_what_next 7) (get_rd))
    )
)
;====================================mode_dp==========================================

(defun mode_dp ()
  (cond
    ((= t_type "t_txt1") (set_tile "dp_wid" " Diam. =") (mode_tile "dp_heg" 1))
    ((= t_type "t_txt2") (set_tile "dp_wid" " Width =") (mode_tile "dp_heg" 0))
  )
  (cond
    ((and (= dp_piece "1") (= dp_type "dp_mitered")) (mode_tile "dp_pcs" 1))
    ((and (= dp_piece "0") (= dp_type "dp_mitered")) (mode_tile "dp_pcs" 0))
    ((= dp_type "dp_radius") (mode_tile "dp_pcs" 1))
  )
)
;====================================dp_opt==========================================

(defun dp_opt ()
  
  (if (not (new_dialog "dp_opt" dcl_id)) (exit))

  (sup_img)
  (exh_img)
  (scl_img)
  (ecl_img)
  (stl_img)
  (etl_img)
  (sac_img)
  (eac_img)

  (setq sup_lyr_old sup_lyr
	exh_lyr_old exh_lyr
	scl_lyr_old scl_lyr
	ecl_lyr_old ecl_lyr
	stl_lyr_old stl_lyr
	etl_lyr_old etl_lyr
	sac_lyr_old sac_lyr
	eac_lyr_old eac_lyr
	sup_clr_old sup_clr 
	exh_clr_old exh_clr
	scl_clr_old scl_clr
	ecl_clr_old ecl_clr
	stl_clr_old stl_clr
	etl_clr_old etl_clr
	sac_clr_old sac_clr
	eac_clr_old eac_clr
  )

  (action_tile "dp_sav" "(done_dialog 6)")
  (action_tile "dp_can" "(done_dialog 5)")
  
  (action_tile "dp_sup"  "(setq sup_lyr $value)")
  (action_tile "dp_exh"  "(setq exh_lyr $value)")
  (action_tile "dp_scl"  "(setq scl_lyr $value)")
  (action_tile "dp_ecl"  "(setq ecl_lyr $value)")
  (action_tile "dp_stl"  "(setq stl_lyr $value)")
  (action_tile "dp_etl"  "(setq etl_lyr $value)")
  (action_tile "dp_sac"  "(setq sac_lyr $value)")
  (action_tile "dp_eac"  "(setq eac_lyr $value)")
  
  (action_tile "dp_sup_clr"  "(sup_set)")
  (action_tile "dp_exh_clr"  "(exh_set)")
  (action_tile "dp_scl_clr"  "(scl_set)")
  (action_tile "dp_ecl_clr"  "(ecl_set)")
  (action_tile "dp_stl_clr"  "(stl_set)")
  (action_tile "dp_etl_clr"  "(etl_set)")
  (action_tile "dp_sac_clr"  "(sac_set)")
  (action_tile "dp_eac_clr"  "(eac_set)")

  (set_tile "dp_sup"  sup_lyr)
  (set_tile "sup_clr" (itoa sup_clr))
  (set_tile "dp_exh"  exh_lyr)
  (set_tile "exh_clr" (itoa exh_clr))
  (set_tile "dp_scl"  scl_lyr)
  (set_tile "scl_clr" (itoa scl_clr))
  (set_tile "dp_ecl"  ecl_lyr)
  (set_tile "ecl_clr" (itoa ecl_clr))
  (set_tile "dp_stl"  stl_lyr)
  (set_tile "stl_clr" (itoa stl_clr))
  (set_tile "dp_etl"  etl_lyr)
  (set_tile "etl_clr" (itoa etl_clr))
  (set_tile "dp_sac"  sac_lyr)
  (set_tile "sac_clr" (itoa sac_clr))
  (set_tile "dp_eac"  eac_lyr)
  (set_tile "eac_clr" (itoa eac_clr))

  (setq dp_what_next (start_dialog))
  (cond
    ((= dp_what_next 5)(setq sup_lyr sup_lyr_old
	                     exh_lyr exh_lyr_old 
	                     scl_lyr scl_lyr_old 
	                     ecl_lyr ecl_lyr_old 
	                     stl_lyr stl_lyr_old 
	                     etl_lyr etl_lyr_old
			     sac_lyr sac_lyr_old
			     eac_lyr eac_lyr_old
			     sup_clr sup_clr_old
	                     exh_clr exh_clr_old 
	                     scl_clr scl_clr_old 
	                     ecl_clr ecl_clr_old 
	                     stl_clr stl_clr_old 
	                     etl_clr etl_clr_old
			     sac_clr sac_clr_old
			     eac_clr eac_clr_old
                        ))
    ((= dp_what_next 6)(save_dp))
  )
)
;;;=============================check_de_top===================================

(defun check_dp ()
  
  (if (<= (atof dp_txt) 0)
    (progn
      (alert
        "Improper Text Heigth value!
        \nPlease input proper
        \ngreater than 0."
      )
      (setq dp_txt dp_txt_old)
      (set_tile "dp_txt" dp_txt)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof dp_rd) 0.5)
    (progn
      (alert
	"Improper R/D value!
        \nPlease input proper number
        \ngreater than 0.5."
      )
      (setq dp_rd dp_rd_old)
      (set_tile "dp_rd" dp_rd)
      (mode_tile key_name 2)
    )
  )
  (if (> (atof dp_rd) 10)
    (progn
      (alert
	"Improper R/D value!
        \nPlease input proper number
        \nsmaller than 10."
      )
      (setq dp_rd dp_rd_old)
      (set_tile "dp_rd" dp_rd)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof dp_dia) 0.0)
    (progn
      (alert
	"Improper Diam. or Width value!
        \nPlease input proper number
        \ngreater than 0."
      )
      (setq dp_dia dp_dia_old)
      (set_tile "dp_dia" dp_dia)
      (mode_tile key_name 2)
    )
  )
  (if (<= (atof dp_heg) 0.0)
    (progn
      (alert
	"Improper Heigth value!
        \nPlease input proper number
        \ngreater than 0."
      )
      (setq dp_heg dp_heg_old)
      (set_tile "dp_heg" dp_heg)
      (mode_tile key_name 2)
    )
  )
  (if (< (atoi dp_pcs) 2)
    (progn
      (alert
	"Improper Piece value!
        \nPlease input proper integer
        \ngreater than 1."
      )
      (setq dp_pcs dp_pcs_old)
      (set_tile "dp_pcs" dp_pcs)
      (mode_tile key_name 2)
    )
  )
  (if (> (atoi dp_pcs) 10)
    (progn
      (alert
        "Improper Piece value!
        \nPlease input proper integer
        \nsmaller than 10."
      )
      (setq dp_pcs dp_pcs_old)
      (set_tile "dp_pcs" dp_pcs)
      (mode_tile key_name 2)
    )
  )
)
;;;===================================================================================

(defun tan (aa) (/ (sin aa) (cos aa)))
(defun dtr (bb) (/ (* pi bb) 180.0))
(defun kol (cc) (length cc))

;;;================================dp_anl=========================================

(defun dp_anl ()

  (check_eval)

  (check_text)
  
  (setq dp_a1 (getpoint "\nSpecify first point :"))

  (cond
    ((/= dp_a1 nil)
     (setq dp_u1 dp_a1)
     (setq ss_a1 (ssget dp_a1))

     (cond
       ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
        (get_base)
        (get_angle)
       )
       ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))    
        (get_end_base)
        (setq dp_a1 dp_e1)
        (get_angle)
       )
     )
  
     (setq dp_lst (list dp_a1))

     (setq d      (atof dp_dia)
	   rd     (atof dp_rd)
	   pcs    (atoi dp_pcs)
           text_h (atof dp_txt)
	   dp_td  (atof dp_dia)
	   heg    (atof dp_heg)
	   dp_len (atof db_len)
     )

     (dp_anp)
    )
    ((= dp_a1 nil)
     (princ "\nFunction Canceled!")
    )
  )
)
;;;================================dp_anp=========================================

(defun dp_anp ()

  (initget "Undo")
  (setq dp_a2 (getpoint dp_a1 "\nSpecify next point or [Undo] :"))
  (cond
    ((and (/= ss_a1 nil) (= dp_auto "1") (/= dp_a2 nil) (/= dp_a2 "Undo") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_branch)
    )
    ((and (/= ss_a1 nil) (= dp_auto "1") (/= dp_a2 nil) (/= dp_a2 "Undo") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))
     (get_transform)
    )
  )

  (if (and (/= dp_a2 nil) (/= dp_a2 "Undo"))
    (setq ss_a1 (ssget dp_a2))
  )

  (if (and (/= dp_a2 nil) (/= dp_a2 "Undo"))
    (setq dp_ane (angle dp_a1 dp_a2))
  )
  
  (cond
    ((and (/= ss_a1 nil) (= dp_auto "1") (/= dp_a2 nil) (/= dp_a2 "Undo") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_base)
     (setq p5_temp   dp_a1
	   dp_ang2   (angle dp_a1 dp_a2)
           p1_start1 (polar dp_a1 (- dp_ang2 (/ pi 2)) (/ d 2))
           p3_start1 (polar dp_a1 (+ dp_ang2 (/ pi 2)) (/ d 2))
	   p5_txt    dp_a1
     )
     (get_branch_end)
    )

    ((and (/= ss_a1 nil) (= dp_auto "1") (/= dp_a2 nil) (/= dp_a2 "Undo") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))
     (get_end_base)
     (setq dp_a2 dp_e1)
     (setq p5_temp   dp_a1
	   dp_ang2   (angle dp_a1 dp_a2)
           p1_start1 (polar dp_a1 (- dp_ang2 (/ pi 2)) (/ d 2))
           p3_start1 (polar dp_a1 (+ dp_ang2 (/ pi 2)) (/ d 2))
	   p5_txt    dp_a1
     )
     (get_transform_end)
    )
    
    ((and (/= dp_a2 nil) (/= dp_a2 "Undo"))
     (setq dp_lst (append dp_lst (list dp_a2)))
  
     (setq dp_ta  (angle dp_a2 dp_a1)
           dp_tl1 (polar dp_a1 (- dp_ta (/ pi 2)) (/ dp_td 2))
           dp_tl2 (polar dp_a1 (+ dp_ta (/ pi 2)) (/ dp_td 2))
 	   dp_tl3 (polar dp_a2 (- dp_ta (/ pi 2)) (/ dp_td 2))
           dp_tl4 (polar dp_a2 (+ dp_ta (/ pi 2)) (/ dp_td 2))
     )

     (if (= opt_1 "0")
       (setq dp_tt3 nil)
     )

     (command "_.undo" "_group")
     (setvar "osmode" 0)
  
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
         (command "_.color" vp_clr)
       )
     )
     (command "_.line" dp_tl1 dp_tl3 "")
     (setq dp_tt1 (entlast))
     (setq dp_ls1 (list dp_tt1))
     (command "_.line" dp_tl2 dp_tl4 "")
     (setq dp_tt2 (entlast))
     (setq dp_ls2 (list dp_tt2))

     (if (= opt_1 "1")
       (progn
         (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" dp_a1 dp_a2 "")
         (setq dp_tt3 (entlast))
         (setq dp_ls3 (list dp_tt3))
       )
     )

     (setq p5_temp   dp_a1
           dp_ang1   (angle dp_a2 dp_a1)
           p1_start1 (polar dp_a1 (- dp_ang1 (/ pi 2)) (/ d 2))
           p3_start1 (polar dp_a1 (+ dp_ang1 (/ pi 2)) (/ d 2))
	   p5_txt    dp_a1
	   p5_tempe  dp_a1
     )

     (setq dp_pt5 (list p5_temp))

     (setvar "osmode" old_osnap)
     (command "_.undo" "_end") 
     (get_dp_dr)
    )
    ((= dp_a2 "Undo")
     (dp_undo)
    )
    ((= dp_a2 nil)
     (princ "\nFunction Canceled!")
    )
  )
)
;;;=============================get_dp_dr=================================

(defun get_dp_dr ()

  (initget "Undo")
  (setq dp_a3 (getpoint dp_a2 "\nSpecify next point or [Undo] :"))

  (cond  
    ((and (/= dp_a3 nil) (/= dp_a3 "Undo"))
     (setq dp_lst (append dp_lst (list dp_a3)))
     (setq ss_a1  (ssget dp_a3))

     (if (and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))
       (progn
	 (get_end_base)
	 (setq dp_etd T)
         (setq dp_a3 dp_e1)
       )
     )

     (if (and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
       (setq dp_etd T)
     )
     
     (setq dp_ang1 (angle dp_a2 dp_a1)
           dp_ang2 (angle dp_a2 dp_a3)
           dp_ang3 (- dp_ang1 dp_ang2)
     )

     (if (< dp_ang3 0) (setq dp_ang3 (+ (* pi 2) dp_ang3)))
  
     (cond
       ((and (> dp_ang3 0) (< dp_ang3 pi))
        (setq dp_ang (- pi dp_ang3))
	(setq znak     +)
        (setq znak_obr -)
       )
       ((and (> dp_ang3 pi) (< dp_ang3 (* pi 2)))   
        (setq dp_ang (- dp_ang3 pi))
	(setq znak     -)
	(setq znak_obr +)
       )
     )

     (cond
       ((and (not (equal dp_ang3 0 0.0001)) (not (equal dp_ang3 pi 0.0001)))
        (setq l_start p5_temp)
        (get_dp)
       )
       ((or (equal dp_ang3 0 0.0001) (equal dp_ang3 pi 0.0001))
        (setq l_start p5_temp)
        (get_line_dp)
       )
      )
     )
    ((= dp_a3 "Undo")
     (dp_undo)
    )
    ((= dp_a3 nil)
     (setq dp_ang2 (angle p5_temp dp_a2))
     (if (= (kol dp_lst) 2)
       (setq p5_temp   dp_a1
	     dp_ang2   (angle dp_a1 dp_a2)
             p1_start1 (polar dp_a1 (- dp_ang2 (/ pi 2)) (/ d 2))
             p3_start1 (polar dp_a1 (+ dp_ang2 (/ pi 2)) (/ d 2))
	     p5_txt    dp_a1
       )
     )
     (end_dp)
    )
  )
)
;;;=================================Get_dp=======================================

(defun get_dp ()

  (if (= dp_piece "1")
    (progn
      (cond
	((<= dp_ang (/ pi 6))
	 (setq pcs 2)
	)
	((and (>= dp_ang (/ pi 6)) (<= dp_ang (/ pi 3)))
	 (setq pcs 3)
	)
	((and (> dp_ang (/ pi 3)) (< dp_ang (/ pi 1.5)))
	 (setq pcs 4)
	)
	((and (>= dp_ang (/ pi 1.5)) (< dp_ang (/ (* pi 5) 6)))
	 (setq pcs 5)
	)
	((> dp_ang (/ (* pi 5) 6))
	 (setq pcs 7)
	)
      )
    )
  )

  (setq ang   (/ dp_ang (* 2 (- pcs 1)))
        dist1 (* (+ (* rd d) (/ d 2.0)) (tan ang))
        dist2 (* (- (* rd d) (/ d 2.0)) (tan ang))
	dist3 (* (* rd d) (tan ang))
  )

  (setq p1_temp (polar dp_a2 dp_ang1 (* (* rd d) (tan (/ dp_ang 2))))
        p1      (polar p1_temp (znak dp_ang1 (/ pi 2)) (/ d 2.0))
        p2      (polar p1 (znak dp_ang1 pi) dist1)
        p3      (polar p1 (znak_obr dp_ang1 (/ pi 2)) d)
        p4      (polar p3 (znak dp_ang1 pi) dist2)
	p12     (polar p1_temp (znak dp_ang1 pi) dist3)

        p9      (polar p1_temp (znak_obr dp_ang1 (/ pi 2)) (* rd d))
        p5_temp (polar p9 (znak (angle p9 p1_temp) dp_ang) (* rd d))
        p5      (polar p5_temp (angle p9 p5_temp) (/ d 2.0))
        p6      (polar p5 (znak (angle p5_temp p9) (/ pi 2)) dist1)
        p7      (polar p5 (angle p5_temp p9) d)
        p8      (polar p7 (znak (angle p5_temp p9) (/ pi 2)) dist2)
        p5_temp_dir (polar p5_temp (znak (angle p5_temp p9) (dtr 90)) 5)
        p5_dir  (polar p5 (znak (angle p5_temp p9) (/ pi 2)) 5)
        p7_dir  (polar p7 (znak (angle p5_temp p9) (/ pi 2)) 5)
	p14     (polar p5_temp (angle p5_temp dp_a2) dist3)
  )

  (setq dp_pt5 (append dp_pt5 (list p5_temp)))

  (setq p1_start (polar l_start (znak     dp_ang1 (/ pi 2)) (/ d 2))
	p3_start (polar l_start (znak_obr dp_ang1 (/ pi 2)) (/ d 2.0))
  )

  (setq p_text (list (/ (+ (car p5_txt) (car p1_temp)) 2) (/ (+ (cadr p5_txt) (cadr p1_temp)) 2))
  )

  (cond
    ((and (>= dp_ang1 0) (<= dp_ang1 (/ pi 2)))
     (setq p_text (polar p_text (+ dp_ang1 (/ pi 2)) (/ d 2)))
    )
    ((and (> dp_ang1 (/ pi 2)) (<= dp_ang1 (/ (* pi 3) 2)))
     (setq p_text (polar p_text (- dp_ang1 (/ pi 2)) (/ d 2)))
    )
    ((and (> dp_ang1 (/ (* pi 3) 2)) (<= dp_ang1 (* pi 2)))
     (setq p_text (polar p_text (+ dp_ang1 (/ pi 2)) (/ d 2)))
    )
  )
  	
  (cond
    ((and (>= dp_ang1 0) (<= dp_ang1 (/ pi 2)))
     (setq a_text (* dp_ang1 (/ 180 pi)))
    )
    ((and (> dp_ang1 (/ pi 2)) (<= dp_ang1 (/ (* pi 3) 2)))
     (setq a_text (* (- dp_ang1 pi) (/ 180 pi)))
    )
    ((and (> dp_ang1 (/ (* pi 3) 2)) (<= dp_ang1 (* pi 2)))
     (setq a_text (* dp_ang1 (/ 180 pi)))
    )
  )
;;;=================================Radius=======================================

  (cond
    ((= dp_type "dp_radius")
     
     (command "_.undo" "_group")
     (setvar "osmode" 0)

     (setq dp_td1 (entdel dp_tt1))
     (setq dp_td2 (entdel dp_tt2))
     (if (= opt_1 "1")
       (setq dp_td3 (entdel dp_tt3))
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1_start p1 "")
     (setq x_pipl (entlast))
     (setq x_pipl_ang (angle p1_start p3_start))
     (command "_.line" p3_start p3 "")
     (setq x_pipr (entlast))
     (setq x_pipr_ang (angle p3_start p1_start))
     (get_data)

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" l_start p1_temp "")
       )
     )

     (setvar "angbase" 0)
     (if (and (= dp_text "1") (> (distance p5_txt p1_temp) (* text_h 7)))
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	     (command "_.color" tl_clr)
           )
         )
	 (cond
	   ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
           ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
	 )
       )
     )
     (if ab_mda
       (setvar "angbase" ab_mda)
       (setvar "angbase" angbase_old)
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
  
     (command "_.line" p7 p5 "")
     (command "_.arc" p5 "_e" p1 "_d" p5_dir)
     (command "_.arc" p7 "_e" p3 "_d" p7_dir)
     (command "_.line" p3 p1 "") 
  
     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.arc" p5_temp "_e" p1_temp "_d" p5_temp_dir)
       )
     )
    )	  
;;;===============================Mitered===================================

    ((= dp_type "dp_mitered")
     
     (command "_.undo" "_group")
     (setvar "osmode" 0)
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1_start p1 "")
     (setq x_pipl (entlast))
     (setq x_pipl_ang (angle p1_start p3_start))
     (command "_.line" p3_start p3 "")
     (setq x_pipr (entlast))
     (setq x_pipr_ang (angle p3_start p1_start))
     (get_data)

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" l_start p1_temp "")
       )
     )

     (if (and (= dp_text "1") (> (distance p5_txt p1_temp) (* text_h 7)))
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	     (command "_.color" tl_clr)
           )
         )
	 (setvar "angbase" 0)
	 (cond
	   ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
           ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
	 )
	 (if ab_mda
           (setvar "angbase" ab_mda)
           (setvar "angbase" angbase_old)
         )
       )
     )
  
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )

     (command "_.line" p1 p3 "")
     (command "_.line" p1 p2 "")
     (command "_.line" p3 p4 "")
     (command "_.line" p2 p4 "")
  
     (setq gross_ang (znak dp_ang1 pi))
     (repeat (- pcs 2)
       (setq gross_ang (znak gross_ang (* 2.0 ang)))
       (setq p10 (polar p2 gross_ang (* 2.0 dist1)))
       (setq p11 (polar p4 gross_ang (* 2.0 dist2)))
       (command "_.line" p2  p10 "")
       (command "_.line" p4  p11 "")
       (command "_.line" p10 p11 "")
       (setq p2 p10)
       (setq p4 p11)
     )

     (if (= opt_1 "1")
       (progn
	 (if (= de_lay "1")
           (progn
             (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	     (command "_.color" cl_clr)
           )
         )
         (command "_.line" p1_temp p12 "")
	 (setq gross_ang (znak dp_ang1 pi))
         (repeat (- pcs 2)
           (setq gross_ang (znak gross_ang (* 2.0 ang)))
           (setq p13 (polar p12 gross_ang (* 2.0 dist3)))
           (command "_.line" p12 p13 "")
           (setq p12 p13)
         )
	 (command "_.line" p14 p5_temp "")
       )
     )
     
     (if (= de_lay "1")
       (progn
         (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
	 (command "_.color" vp_clr)
       )
     )
    
     (command "_.line" p6 p5 "")
     (command "_.line" p8 p7 "")
     (command "_.line" p5 p7 "")

     (setq dp_td1 (entdel dp_tt1))
     (setq dp_td2 (entdel dp_tt2))
     (if (= opt_1 "1")
       (setq dp_td3 (entdel dp_tt3))
     )
     
    )
  )

  (setq dp_ta  (angle p5_temp dp_a3)
        dp_tl1 (polar p5_temp (- dp_ta (/ pi 2)) (/ dp_td 2))
        dp_tl2 (polar p5_temp (+ dp_ta (/ pi 2)) (/ dp_td 2))
	dp_tl3 (polar dp_a3   (- dp_ta (/ pi 2)) (/ dp_td 2))
        dp_tl4 (polar dp_a3   (+ dp_ta (/ pi 2)) (/ dp_td 2))
  )
  
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (if (null dp_etd)
    (progn
      (command "_.line" dp_tl1 dp_tl3 "")
      (setq dp_tt1 (entlast))
      (setq dp_ls1 (append dp_ls1 (list dp_tt1)))
      (command "_.line" dp_tl2 dp_tl4 "")
      (setq dp_tt2 (entlast))
      (setq dp_ls2 (append dp_ls2 (list dp_tt2)))

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (command "_.line" p5_temp dp_a3 "")
          (setq dp_tt3 (entlast))
          (setq dp_ls3 (append dp_ls3 (list dp_tt3)))
        )
      )
    )
  )    

  (setq p5_txt p5_temp)

  (setq dp_a1 dp_a2
        dp_a2 dp_a3
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")

  (cond
    ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_base)
     (get_branch_final)
    )
    ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))
     (get_end_base)
     (setq dp_a2 dp_e1)
     (get_transform_final)
    )
    (T
     (get_dp_dr)
    )
  )
)
;;;================================get_line_dp========================================

(defun get_line_dp ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)
  
  (setq dp_td1 (entdel dp_tt1))
  (setq dp_td2 (entdel dp_tt2))
  (if (= opt_1 "1")
    (setq dp_td3 (entdel dp_tt3))
  )
  
  (setq p1_start (polar l_start (- dp_ang1 (/ pi 2)) (/ d 2))
	p3_start (polar l_start (+ dp_ang1 (/ pi 2)) (/ d 2))
	p1_end   (polar dp_a2   (- dp_ang1 (/ pi 2)) (/ d 2))
	p3_end   (polar dp_a2   (+ dp_ang1 (/ pi 2)) (/ d 2))
	p5_temp  dp_a2
  )

  (setq dp_pt5 (append dp_pt5 (list p5_temp)))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)
  
  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" l_start p5_temp "")
    )
  )

  (setq dp_ta  (angle dp_a3 dp_a2)
        dp_tl1 (polar dp_a2 (- dp_ta (/ pi 2)) (/ dp_td 2))
        dp_tl2 (polar dp_a2 (+ dp_ta (/ pi 2)) (/ dp_td 2))
	dp_tl3 (polar dp_a3 (- dp_ta (/ pi 2)) (/ dp_td 2))
        dp_tl4 (polar dp_a3 (+ dp_ta (/ pi 2)) (/ dp_td 2))
  )

  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (if (null dp_etd)
    (progn
      (command "_.line" dp_tl1 dp_tl3 "")
      (setq dp_tt1 (entlast))
      (setq dp_ls1 (append dp_ls1 (list dp_tt1)))
      (command "_.line" dp_tl2 dp_tl4 "")
      (setq dp_tt2 (entlast))
      (setq dp_ls2 (append dp_ls2 (list dp_tt2)))

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (command "_.line" dp_a2 dp_a3 "")
          (setq dp_tt3 (entlast))
          (setq dp_ls3 (append dp_ls3 (list dp_tt3)))
        )
      )
    )
  )

  (setq dp_a1 dp_a2
        dp_a2 dp_a3
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")

  (cond
    ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_base)
     (get_branch_final)
    )
    ((and (/= ss_a1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_end")))))
     (get_end_base)
     (setq dp_a2 dp_e1)
     (get_transform_final)
    )
    (T
     (get_dp_dr)
    )
  )
)
;;;==================================End_de======================================

(defun end_dp ()

  (txt_opt)

  (command "_.undo" "_group")
  (setvar "osmode" 0)
  
  (setq dp_td1 (entdel dp_tt1))
  (setq dp_td2 (entdel dp_tt2))
  (if (= opt_1 "1")
    (setq dp_td3 (entdel dp_tt3))
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" p5_temp dp_a2 "")
    )
  )
    
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)

  (if (and (= dp_end "1")(= db_dls nil))
    (progn
      (command "_.line" p1_start1 p3_start1 "")
      (setq x_end (entlast))
      (setq x_end_ang dp_ane)
      (setq x_ept p5_tempe)
      (get_end_data)
    )
  )
  (if (= dp_end "1")
    (progn
      (command "_.line" p1_end p3_end "")
      (setq x_end (entlast))
      (setq x_end_ang (angle p3_end p3_start))
      (setq x_ept dp_a2)
      (get_end_data)
    )
  )

  (if (and (= dp_text "1") (> (distance p5_txt dp_a2) (* text_h 7)))
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	  (command "_.color" tl_clr)
        )
      )
      (setvar "angbase" 0)
      (cond
        ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
        ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
      )
      (setvar "angbase" angbase_old)
    )
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")  
)
;================================txt_opt=====================================
(defun txt_opt ()

  (setq	p1_start (polar p5_temp (- dp_ang2 (/ pi 2)) (/ d 2))
	p3_start (polar p5_temp (+ dp_ang2 (/ pi 2)) (/ d 2))
	p1_end   (polar dp_a2   (- dp_ang2 (/ pi 2)) (/ d 2))
	p3_end   (polar dp_a2   (+ dp_ang2 (/ pi 2)) (/ d 2))
  )

  (setq p_text (list (/ (+ (car p5_txt) (car dp_a2)) 2) (/ (+ (cadr p5_txt) (cadr dp_a2)) 2)))

  (cond
    ((and (>= dp_ang2 0) (<= dp_ang2 (/ pi 2)))
     (setq p_text (polar p_text (+ dp_ang2 (/ pi 2)) (/ d 2)))
    )
    ((and (> dp_ang2 (/ pi 2)) (<= dp_ang2 (/ (* pi 3) 2)))
     (setq p_text (polar p_text (- dp_ang2 (/ pi 2)) (/ d 2)))
    )
    ((and (> dp_ang2 (/ (* pi 3) 2)) (<= dp_ang2 (* pi 2)))
     (setq p_text (polar p_text (+ dp_ang2 (/ pi 2)) (/ d 2)))
    )
  )
  	
  (cond
    ((and (>= dp_ang2 0) (<= dp_ang2 (/ pi 2)))
     (setq a_text (* dp_ang2 (/ 180 pi)))
    )
    ((and (> dp_ang2 (/ pi 2)) (<= dp_ang2 (/ (* pi 3) 2)))
     (setq a_text (* (- dp_ang2 pi) (/ 180 pi)))
    )
    ((and (> dp_ang2 (/ (* pi 3) 2)) (<= dp_ang2 (* pi 2)))
     (setq a_text (* dp_ang2 (/ 180 pi)))
    )
  )
)
;================================dp_undo=====================================

(defun dp_undo ()

  (setq dp_lpc (length dp_lst))

  (cond
    ((>= dp_lpc 3)
     
     (setq dp_pa3 (- dp_lpc 1))
     (setq dp_pa2 (- dp_lpc 2))
     (setq dp_pa1 (- dp_lpc 3))
     
     (command "_.u")
     (princ "\nUndo")
  
     (setq dp_a2 (nth dp_pa2 dp_lst))
     (setq dp_a1 (nth dp_pa1 dp_lst))
     (setq dp_lst (vl-remove (nth dp_pa3 dp_lst) dp_lst))

     (setq dp_lp1 (length dp_ls1))
     (setq dp_le1 (- dp_lp1 1))
     (setq dp_lb1 (- dp_lp1 2))
     (setq dp_tt1 (nth dp_lb1 dp_ls1))
     (setq dp_ls1 (vl-remove (nth dp_le1 dp_ls1) dp_ls1))

     (setq dp_lp2 (length dp_ls2))
     (setq dp_le2 (- dp_lp2 1))
     (setq dp_lb2 (- dp_lp1 2))
     (setq dp_tt2 (nth dp_lb2 dp_ls2))
     (setq dp_ls2 (vl-remove (nth dp_le2 dp_ls2) dp_ls2))

     (if (= opt_1 "1")
       (progn
	 (setq dp_lp3 (length dp_ls3))
         (setq dp_le3 (- dp_lp3 1))
         (setq dp_lb3 (- dp_lp1 2))
         (setq dp_tt3 (nth dp_lb3 dp_ls3))
         (setq dp_ls3 (vl-remove (nth dp_le3 dp_ls3) dp_ls3))
       )
     )

     (setq dp_lp5 (length dp_pt5))
     (setq dp_le5 (- dp_lp5 1))
     (setq dp_lb5 (- dp_lp5 2))
     (setq dp_tt5 (nth dp_lb5 dp_pt5))
     (setq dp_pt5 (vl-remove (nth dp_le5 dp_pt5) dp_pt5))
     (setq p5_temp dp_tt5)
     (setq p5_txt p5_temp)

     (get_dp_dr)
    )
    ((= dp_lpc 2)
     
     (setq dp_pa2 (- dp_lpc 1))
     (setq dp_pa1 (- dp_lpc 2))

     (command "_.u")
     (if (= db_gbs T)
       (progn
	 (command "_.u")
	 (setq ss_a1 (ssget dp_u1))
	 (setq db_dls nil)
	 (get_angle)
	 (setq db_gbs nil)
       )
     )
     (if (= db_gbs nil)
       (setq ss_a1 (ssget dp_u1))
     )
     (princ "\nUndo")
     
     (setq dp_a1 (nth dp_pa1 dp_lst))
     (setq dp_lst (vl-remove (nth dp_pa2 dp_lst) dp_lst))
     
     (setq dp_lp1 nil)
     (setq dp_tt1 nil)

     (setq dp_lp2 nil)
     (setq dp_tt2 nil)

     (setq dp_lp3 nil)
     (setq dp_tt3 nil)

     (setq dp_lp5  nil)
     (setq dp_tt5  nil)
     (setq p5_temp nil)
     (setq p5_txt  nil)

     (dp_anp)
    )
    ((= dp_lpc 1)

     (princ "\nAll segments already undone.")

     (setvar "angbase" angbase_old)

     (setq db_dls nil)
     
     (setq dp_lst nil)

     (dp_anl)
    ) 
  )
)
;===============================get_data====================================

(defun get_data ()
  
  (if (not (tblsearch "appid" "HVAC_DUCT"))
    (regapp "HVAC_DUCT")
  )
  
  (cond
    ((= t_type "t_txt1")
     (setq x_list (list (cons 1000 "RND_DUCT")))
     (setq x_list (cons (cons 1040 d) x_list))
    )
    ((= t_type "t_txt2")
     (setq x_list (list (cons 1000 "RECT_DUCT")))
     (setq x_list (cons (cons 1040 d) x_list))
     (setq x_list (cons (cons 1040 heg) x_list))
    )
  )
  (setq x_listl (cons (cons 1040 x_pipl_ang) x_list))
  (setq x_listr (cons (cons 1040 x_pipr_ang) x_list))

  (entmod (cons (list -3 (cons "HVAC_DUCT" x_listl)) (entget x_pipl)))
  (entmod (cons (list -3 (cons "HVAC_DUCT" x_listr)) (entget x_pipr)))
)
;===============================get_end_data====================================

(defun get_end_data ()
  
  (if (not (tblsearch "appid" "HVAC_END"))
    (regapp "HVAC_END")
  )
  
  (cond
    ((= t_type "t_txt1")
     (setq x_list (list (cons 1000 "RND_DUCT")))
     (setq x_list (cons (cons 1011 x_ept) x_list))
     (setq x_list (cons (cons 1040 d) x_list))
    )
    ((= t_type "t_txt2")
     (setq x_list (list (cons 1000 "RECT_DUCT")))
     (setq x_list (cons (cons 1011 x_ept) x_list))
     (setq x_list (cons (cons 1040 d) x_list))
     (setq x_list (cons (cons 1040 heg) x_list))
    )
  )
  (setq x_list (cons (cons 1040 x_end_ang) x_list))

  (entmod (cons (list -3 (cons "HVAC_END" x_list)) (entget x_end)))
) 
;================================get_base=====================================

(defun get_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
    )
  )
)
;================================get_end_base=====================================

(defun get_end_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
  )
)
;================================get_angle=====================================

(defun get_angle ()
  
  (if (and dp_mda (= de_polar "1"))
    (progn
      (setq ab_mda (+ dp_mda pi))
      (setvar "angbase" ab_mda)
    )
  )
)
;================================get_branch=====================================

(defun get_branch ()

  (setq dp_anb (angle dp_a1 dp_a2))

  (if (and (> (abs (- dp_anb dp_mda)) (/ pi 1.8)) (< (abs (- dp_anb dp_mda)) (* (/ pi 2) 2.9)) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn

      (command "_.undo" "_group")
      (setvar "osmode" 0)
      
      (setq db_gbs T)
      (setq db_dls T)
      
      (cond
	((<= (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (- (abs (- dp_anb dp_mda)) (/ pi 2)))
	 (setq znak     +)
	 (setq znak_obr -)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     -)
	     (setq znak_obr +)
	   )
	 )
	 (setq db_b1  (polar dp_a1 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a1 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
         (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
	((> (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (abs (- (+ dp_mda (* (/ pi 2) 3)) dp_anb)))
	 (setq znak     -)
	 (setq znak_obr +)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     +)
	     (setq znak_obr -)
	   )
	 )
	 (setq db_b1  (polar dp_a1 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a1 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
	 (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
      )

      (setq db_br1 (ssget db_b1))
      (setq db_br2 (ssget db_b2))

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (/= db_br1 nil) (/= db_br2 nil) (>= dp_mds d))
	(command "_.break" db_b1 db_b2)
      )

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (setq db_b7 (polar dp_a1 (+ dp_anb pi) (/ (/ dp_mds 2) (sin db_anm))))
          (command "_.line" db_b7 db_b5 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )

      (cond
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (not (equal dp_mds d 1)) (> dp_mds d))
         (setq db_acp (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt d 2.0)))))
         (setq db_b6 (polar dp_a1 (+ dp_anb pi) (/ (/ db_acp 2.0) (sin db_anm))))
         (command "_.arc" db_b1 db_b6 db_b2)
        )
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (equal dp_mds d 1))
         (setq db_b6 (polar dp_a1 (+ dp_anb pi) (/ (/ dp_mds 2.0) (sin db_anm))))
         (command "_.pline" db_b1 db_b6 db_b2 "")
        )
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq db_b6 (polar db_b5 (znak     dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
         (setq db_b7 (polar db_b5 (znak_obr dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
	 (command "_.pline" db_b1 db_b5 db_b2 "")
         (command "_.line"  db_b1 db_b7 "")
         (command "_.line"  db_b2 db_b6 "")
	)
      )

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (>= dp_mds d) (= db_tbr "1"))
	(progn
	  (setq db_b8  (polar db_b1 (znak     dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b9  (polar db_b2 (znak_obr dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b10 (polar db_b8 dp_mda dp_mds))
	  (setq db_b11 (polar db_b9 dp_mda dp_mds))
	  (command "_.pline" db_b1 db_b3 db_b4 db_b2 db_b9 db_b11 db_b10 db_b8 db_b1 "")
	)
	(command "_.pline" db_b1 db_b3 db_b4 db_b2 "")
      )

      (setq dp_a1 db_b5)
      (setvar "osmode"  old_osnap)
      (command "_.undo" "_end")
    )
  )
)
;================================get_branch_end=====================================

(defun get_branch_end ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)

  (setq dp_anb (angle dp_a2 dp_a1))
  
  (if (and (> (abs (- dp_anb dp_mda)) (/ pi 1.8)) (< (abs (- dp_anb dp_mda)) (* (/ pi 2) 2.9)) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn
      (setq db_dle T)
      (cond
	((<= (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (- (abs (- dp_anb dp_mda)) (/ pi 2)))
	 (setq znak     +)
	 (setq znak_obr -)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     -)
	     (setq znak_obr +)
	   )
	 )
	 (setq db_b1  (polar dp_a2 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a2 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
         (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
	((> (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (abs (- (+ dp_mda (* (/ pi 2) 3)) dp_anb)))
	 (setq znak     -)
	 (setq znak_obr +)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     +)
	     (setq znak_obr -)
	   )
	 )
	 (setq db_b1  (polar dp_a2 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a2 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
	 (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
      )

      (setq db_br1 (ssget db_b1))
      (setq db_br2 (ssget db_b2))

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (/= db_br1 nil) (/= db_br2 nil) (>= dp_mds d))
	(command "_.break" db_b1 db_b2)
      )

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (setq db_b7 (polar dp_a2 (+ dp_anb pi) (/ (/ dp_mds 2) (sin db_anm))))
          (command "_.line" db_b7 db_b5 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )

      (cond
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (not (equal dp_mds d 1)) (> dp_mds d))
         (setq db_acp (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt d 2.0)))))
         (setq db_b6 (polar dp_a2 (+ dp_anb pi) (/ (/ db_acp 2.0) (sin db_anm))))
         (command "_.arc" db_b1 db_b6 db_b2)
        )
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (equal dp_mds d 1))
         (setq db_b6 (polar dp_a2 (+ dp_anb pi) (/ (/ dp_mds 2.0) (sin db_anm))))
         (command "_.pline" db_b1 db_b6 db_b2 "")
        )
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq db_b6 (polar db_b5 (znak     dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
         (setq db_b7 (polar db_b5 (znak_obr dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
	 (command "_.pline" db_b1 db_b5 db_b2 "")
         (command "_.line"  db_b1 db_b7 "")
         (command "_.line"  db_b2 db_b6 "")
	)
      )

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (>= dp_mds d) (= db_tbr "1"))
	(progn
	  (setq db_b8  (polar db_b1 (znak     dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b9  (polar db_b2 (znak_obr dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b10 (polar db_b8 dp_mda dp_mds))
	  (setq db_b11 (polar db_b9 dp_mda dp_mds))
	  (command "_.pline" db_b1 db_b3 db_b4 db_b2 db_b9 db_b11 db_b10 db_b8 db_b1 "")
	)
	(command "_.pline" db_b1 db_b3 db_b4 db_b2 "")
      )

      (setq dp_a2 db_b5)
    )
  )

  (txt_opt)

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" p5_temp dp_a2 "")
    )
  )
    
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)

  (if (and (= dp_end "1")(= db_dls nil))
    (progn
      (command "_.line" p1_start1 p3_start1 "")
      (setq x_end (entlast))
      (setq x_end_ang dp_ane)
      (setq x_ept p5_temp)
      (get_end_data)
    )
  )
  (if (and (= dp_end "1")(= db_dle nil))
    (progn
      (command "_.line" p1_end p3_end "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dp_a2)
      (get_end_data)
    )
  )

  (if (and (= dp_text "1") (> (distance p5_txt dp_a2) (* text_h 7)))
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	  (command "_.color" tl_clr)
        )
      )
      (setvar "angbase" 0)
      (cond
        ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
        ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
      )
      (setvar "angbase" angbase_old)
    )
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")
)
;================================get_branch_final=====================================

(defun get_branch_final ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)

  (setq dp_anb (angle dp_a2 dp_a1))
  
  (if (and (> (abs (- dp_anb dp_mda)) (/ pi 1.8)) (< (abs (- dp_anb dp_mda)) (* (/ pi 2) 2.9)) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn
      (setq db_dle T)
      (cond
	((<= (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (- (abs (- dp_anb dp_mda)) (/ pi 2)))
	 (setq znak     +)
	 (setq znak_obr -)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     -)
	     (setq znak_obr +)
	   )
	 )
	 (setq db_b1  (polar dp_a2 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a2 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
         (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
	((> (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (abs (- (+ dp_mda (* (/ pi 2) 3)) dp_anb)))
	 (setq znak     -)
	 (setq znak_obr +)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     +)
	     (setq znak_obr -)
	   )
	 )
	 (setq db_b1  (polar dp_a2 (znak     dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
         (setq db_b2  (polar dp_a2 (znak_obr dp_mda (/ pi 2)) (/ (/ d 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb dp_len))
	 (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) d))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ d 2)))
	)
      )

      (setq db_br1 (ssget db_b1))
      (setq db_br2 (ssget db_b2))

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (/= db_br1 nil) (/= db_br2 nil) (>= dp_mds d))
        (command "_.break" db_b1 db_b2)
      )

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (setq db_b7 (polar dp_a2 (+ dp_anb pi) (/ (/ dp_mds 2) (sin db_anm))))
          (command "_.line" db_b7 db_b5 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )

      (cond
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (not (equal dp_mds d 1)) (> dp_mds d))
         (setq db_acp (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt d 2.0)))))
         (setq db_b6 (polar dp_a2 (+ dp_anb pi) (/ (/ db_acp 2.0) (sin db_anm))))
         (command "_.arc" db_b1 db_b6 db_b2)
        )
        ((and (= d_type "RND_DUCT") (= t_type "t_txt1") (equal dp_mds d 1))
         (setq db_b6 (polar dp_a2 (+ dp_anb pi) (/ (/ dp_mds 2.0) (sin db_anm))))
         (command "_.pline" db_b1 db_b6 db_b2 "")
        )
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq db_b6 (polar db_b5 (znak     dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
         (setq db_b7 (polar db_b5 (znak_obr dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2.0))))
	 (command "_.pline" db_b1 db_b5 db_b2 "")
         (command "_.line"  db_b1 db_b7 "")
         (command "_.line"  db_b2 db_b6 "")
	)
      )

      (if (and (= d_type "RND_DUCT") (= t_type "t_txt1") (>= dp_mds d) (= db_tbr "1"))
	(progn
	  (setq db_b8  (polar db_b1 (znak     dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b9  (polar db_b2 (znak_obr dp_mda (/ pi 2)) (/ dp_len 2)))
	  (setq db_b10 (polar db_b8 dp_mda dp_mds))
	  (setq db_b11 (polar db_b9 dp_mda dp_mds))
	  (command "_.pline" db_b1 db_b3 db_b4 db_b2 db_b9 db_b11 db_b10 db_b8 db_b1 "")
	)
	(command "_.pline" db_b1 db_b3 db_b4 db_b2 "")
      )
      
      (setq dp_a2 db_b5)
    )
  )
  
  (txt_opt)

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" p5_temp dp_a2 "")
    )
  )
    
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)

  (if (and (= dp_end "1")(= db_dls nil))
    (progn
      (command "_.line" p1_start1 p3_start1 "")
      (setq x_end (entlast))
      (setq x_end_ang dp_ane)
      (setq x_ept p5_tempe)
      (get_end_data)
    )
  )
  (if (and (= dp_end "1")(= db_dle nil))
    (progn
      (command "_.line" p1_end p3_end "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dp_a2)
      (get_end_data)
    )
  )

  (if (and (= dp_text "1") (> (distance p5_txt dp_a2) (* text_h 7)))
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	  (command "_.color" tl_clr)
        )
      )
      (setvar "angbase" 0)
      (cond
        ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
        ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
      )
      (setvar "angbase" angbase_old)
    )
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end") 
)
;================================get_transform=====================================

(defun get_transform ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)

  (setq dp_anb (angle dp_a1 dp_a2))

  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (= dp_mds d))
    (progn
      (entdel (ssname ss_a1 0))
      (setq db_gbs T)
      (setq db_dls T)
    )
  )
  
  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (/= dp_mds d) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn
      
      (setq db_gbs T)
      (setq db_dls T)
      
      (setq dt_ln (/ (max d dp_mds) 2))
      
      (setq dt_t1 (polar dp_a1 dp_anb dt_ln))
      (setq dt_t2 (polar dp_a1 (+ dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t3 (polar dp_a1 (- dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t4 (polar dt_t1 (+ dp_anb (/ pi 2)) (/ d 2)))
      (setq dt_t5 (polar dt_t1 (- dp_anb (/ pi 2)) (/ d 2)))

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (command "_.line" dp_a1 dt_t1 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )
      
      (command "_.line" dt_t2 dt_t4 "")
      (command "_.line" dt_t3 dt_t5 "")
      (command "_.line" dt_t4 dt_t5 "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a1 dp_a2))
      (setq x_ept dt_t1)
      (get_end_data)

      (cond
	((and (= d_type "RND_DUCT") (= t_type "t_txt2"))
	 (setq dt_t6 (polar dp_a1 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (setq dt_t7 (polar dp_a1 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (command "_.line" dt_t4 dp_a1 "")
	 (command "_.line" dt_t5 dp_a1 "")
	 (command "_.line" dt_t4 dt_t6 "")
	 (command "_.line" dt_t5 dt_t7 "")
	)
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq dt_t6 (polar dt_t1 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (setq dt_t7 (polar dt_t1 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (command "_.line" dt_t2 dt_t1 "")
	 (command "_.line" dt_t3 dt_t1 "")
	 (command "_.line" dt_t2 dt_t6 "")
	 (command "_.line" dt_t3 dt_t7 "")
	)
      )
      
      (setq dp_a1 dt_t1)
    )
  )
  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")
)
;================================get_transform_end=====================================

(defun get_transform_end ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)

  (setq dp_anb (angle dp_a2 dp_a1))

  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (= dp_mds d))
    (progn
      (entdel (ssname ss_a1 0))
      (setq db_gbs T)
      (setq db_dle T)
    )
  )

  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (/= dp_mds d) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn
      
      (setq db_gbs T)
      (setq db_dle T)
      
      (setq dt_ln (/ (max d dp_mds) 2))
      
      (setq dt_t1 (polar dp_a2 dp_anb dt_ln))
      (setq dt_t2 (polar dp_a2 (+ dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t3 (polar dp_a2 (- dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t4 (polar dt_t1 (+ dp_anb (/ pi 2)) (/ d 2)))
      (setq dt_t5 (polar dt_t1 (- dp_anb (/ pi 2)) (/ d 2)))

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (command "_.line" dp_a2 dt_t1 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )
      
      (command "_.line" dt_t2 dt_t4 "")
      (command "_.line" dt_t3 dt_t5 "")
      (command "_.line" dt_t4 dt_t5 "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dt_t1)
      (get_end_data)

      (cond
	((and (= d_type "RND_DUCT") (= t_type "t_txt2"))
	 (setq dt_t6 (polar dp_a2 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (setq dt_t7 (polar dp_a2 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (command "_.line" dt_t4 dp_a2 "")
	 (command "_.line" dt_t5 dp_a2 "")
	 (command "_.line" dt_t4 dt_t6 "")
	 (command "_.line" dt_t5 dt_t7 "")
	)
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq dt_t6 (polar dt_t1 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (setq dt_t7 (polar dt_t1 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (command "_.line" dt_t2 dt_t1 "")
	 (command "_.line" dt_t3 dt_t1 "")
	 (command "_.line" dt_t2 dt_t6 "")
	 (command "_.line" dt_t3 dt_t7 "")
	)
      )
      
      (setq dp_a2 dt_t1)
    )
  )

  (txt_opt)

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" p5_temp dp_a2 "")
    )
  )
    
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)

  (if (and (= dp_end "1")(= db_dls nil))
    (progn
      (command "_.line" p1_start1 p3_start1 "")
      (setq x_end (entlast))
      (setq x_end_ang dp_ane)
      (setq x_ept p5_temp)
      (get_end_data)
    )
  )
  (if (and (= dp_end "1")(= db_dle nil))
    (progn
      (command "_.line" p1_end p3_end "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dp_a2)
      (get_end_data)
    )
  )

  (if (and (= dp_text "1") (> (distance p5_txt dp_a2) (* text_h 7)))
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	  (command "_.color" tl_clr)
        )
      )
      (setvar "angbase" 0)
      (cond
        ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
        ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
      )
      (setvar "angbase" angbase_old)
    )
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end")
)
;================================get_transform_final=====================================

(defun get_transform_final ()

  (command "_.undo" "_group")
  (setvar "osmode" 0)

  (setq dp_anb (angle dp_a2 dp_a1))

  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (= dp_mds d))
    (progn
      (entdel (ssname ss_a1 0))
      (setq db_gbs T)
      (setq db_dle T)
    )
  )

  (if (and (equal (abs (- dp_anb dp_mda)) pi 0.0001) (/= dp_mds d) (> (distance dp_a1 dp_a2) (* rd d 2)))
    (progn
      
      (setq db_gbs T)
      (setq db_dle T)
      
      (setq dt_ln (/ (max d dp_mds) 2))
      
      (setq dt_t1 (polar dp_a2 dp_anb dt_ln))
      (setq dt_t2 (polar dp_a2 (+ dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t3 (polar dp_a2 (- dp_anb (/ pi 2)) (/ dp_mds 2.0)))
      (setq dt_t4 (polar dt_t1 (+ dp_anb (/ pi 2)) (/ d 2)))
      (setq dt_t5 (polar dt_t1 (- dp_anb (/ pi 2)) (/ d 2)))

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (command "_.line" dp_a2 dt_t1 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )
      
      (command "_.line" dt_t2 dt_t4 "")
      (command "_.line" dt_t3 dt_t5 "")
      (command "_.line" dt_t4 dt_t5 "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dt_t1)
      (get_end_data)

      (cond
	((and (= d_type "RND_DUCT") (= t_type "t_txt2"))
	 (setq dt_t6 (polar dp_a2 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (setq dt_t7 (polar dp_a2 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ dp_mds 2.0))))
	 (command "_.line" dt_t4 dp_a2 "")
	 (command "_.line" dt_t5 dp_a2 "")
	 (command "_.line" dt_t4 dt_t6 "")
	 (command "_.line" dt_t5 dt_t7 "")
	)
	((and (= d_type "RECT_DUCT") (= t_type "t_txt1"))
	 (setq dt_t6 (polar dt_t1 (+ dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (setq dt_t7 (polar dt_t1 (- dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ d 2))))
	 (command "_.line" dt_t2 dt_t1 "")
	 (command "_.line" dt_t3 dt_t1 "")
	 (command "_.line" dt_t2 dt_t6 "")
	 (command "_.line" dt_t3 dt_t7 "")
	)
      )
      
      (setq dp_a2 dt_t1)
    )
  )

  (txt_opt)

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" cl_lyr "_l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" p5_temp dp_a2 "")
    )
  )
    
  (if (= de_lay "1")
    (progn
      (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (command "_.line" p1_start p1_end "")
  (setq x_pipl (entlast))
  (setq x_pipl_ang (angle p1_start p3_start))
  (command "_.line" p3_start p3_end "")
  (setq x_pipr (entlast))
  (setq x_pipr_ang (angle p3_start p1_start))
  (get_data)

  (if (and (= dp_end "1")(= db_dls nil))
    (progn
      (command "_.line" p1_start1 p3_start1 "")
      (setq x_end (entlast))
      (setq x_end_ang dp_ane)
      (setq x_ept p5_tempe)
      (get_end_data)
    )
  )
  (if (and (= dp_end "1")(= db_dle nil))
    (progn
      (command "_.line" p1_end p3_end "")
      (setq x_end (entlast))
      (setq x_end_ang (angle dp_a2 dp_a1))
      (setq x_ept dp_a2)
      (get_end_data)
    )
  )

  (if (and (= dp_text "1") (> (distance p5_txt dp_a2) (* text_h 7)))
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" tl_lyr "_s" tl_lyr "")
	  (command "_.color" tl_clr)
        )
      )
      (setvar "angbase" 0)
      (cond
        ((= t_type "t_txt1") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat "%%c" (rtos d 2 0))))
        ((= t_type "t_txt2") (command "_.text" "_j" "_bc" p_text text_h a_text (strcat (rtos d 2 0) "x" dp_heg)))
      )
      (setvar "angbase" angbase_old)
    )
  )

  (setvar "osmode" old_osnap)
  (command "_.undo" "_end") 
)
;================================eval_de=====================================

(defun eval_de ()
  (cond
    ((= de_pt "supply")
       (progn
         (setq vp_lyr sup_lyr)
         (setq cl_lyr scl_lyr)
         (setq tl_lyr stl_lyr)
	 (setq ac_lyr sac_lyr)
         (setq vp_clr sup_clr)
         (setq cl_clr scl_clr)
         (setq tl_clr stl_clr)
	 (setq ac_clr sac_clr)
       )
    )
    ((= de_pt "exhaust")
       (progn
         (setq vp_lyr exh_lyr)
         (setq cl_lyr ecl_lyr)
         (setq tl_lyr etl_lyr)
	 (setq ac_lyr eac_lyr)
         (setq vp_clr exh_clr)
         (setq cl_clr ecl_clr)
         (setq tl_clr etl_clr)
	 (setq ac_clr eac_clr)
       )
    )
  )
)
;==================================check_eval=====================================

(defun check_eval ()

  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" vp_lyr))) 0)
      (progn
        (setq vp_st  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rh  (assoc 70 vp_st))
        (setq vp_nch (cons 70 0))
        (setq vp_nst (subst vp_nch vp_rh vp_st))
        (entmod vp_nst)
      )
    )
  )
  
  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" vp_lyr))) 7)
      (progn
        (setq vp_ft  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rf  (assoc 62 vp_ft))
        (setq vp_ncf (cons 62 7))
        (setq vp_fst (subst vp_ncf vp_rf vp_ft))
        (entmod vp_fst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" cl_lyr))) 0)
      (progn
        (setq cl_st  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rh  (assoc 70 cl_st))
        (setq cl_nch (cons 70 0))
        (setq cl_nst (subst cl_nch cl_rh cl_st))
        (entmod cl_nst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" cl_lyr))) 7)
      (progn
        (setq cl_ft  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rf  (assoc 62 cl_ft))
        (setq cl_ncf (cons 62 7))
        (setq cl_fst (subst cl_ncf cl_rf cl_ft))
        (entmod cl_fst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" tl_lyr))) 0)
      (progn
        (setq tl_st  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rh  (assoc 70 tl_st))
        (setq tl_nch (cons 70 0))
        (setq tl_nst (subst tl_nch tl_rh tl_st))
        (entmod tl_nst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" tl_lyr))) 7)
      (progn
        (setq tl_ft  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rf  (assoc 62 tl_ft))
        (setq tl_ncf (cons 62 7))
        (setq tl_fst (subst tl_ncf tl_rf tl_ft))
        (entmod tl_fst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" ac_lyr))) 0)
      (progn
        (setq ac_st  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rh  (assoc 70 ac_st))
        (setq ac_nch (cons 70 0))
        (setq ac_nst (subst ac_nch ac_rh ac_st))
        (entmod ac_nst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" ac_lyr))) 7)
      (progn
        (setq ac_ft  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rf  (assoc 62 ac_ft))
        (setq ac_ncf (cons 62 7))
        (setq ac_fst (subst ac_ncf ac_rf ac_ft))
        (entmod ac_fst)
      )
    )
  )
)
;==================================check_text=====================================

(defun check_text ()
  
  (if (not (tblsearch "style" "HVAC_DUCT"))
    (progn
      (entmake
        (list '(0 . "STYLE")
	      '(100 . "AcDbSymbolTableRecord")
              '(100 . "AcDbTextStyleTableRecord") 
              '(2 . "HVAC_DUCT")
              '(70 . 0)
              '(40 . 0.0)
              '(41 . 1.0)
	      '(50 . 0.0)
	      '(71 . 0)
	      '(42 . 200.0)
	      '(3 . "simplex.shx")
	      '(4 . "")
              '(70 . 0)
        )
      )
    )
  )
  
  (if (/= (cdr (assoc 40 (tblsearch "style" "HVAC_DUCT"))) 0)
    (progn
      (setq txt_st  (entget (tblobjname "style" "HVAC_DUCT")))
      (setq txt_rh  (assoc 40 txt_st))
      (setq txt_nch (cons 40 0))
      (setq txt_nst (subst txt_nch txt_rh txt_st))
      (entmod txt_nst)
    )
  )

  (setvar "textstyle" "HVAC_DUCT")
)
;;;=================================dp_gds======================================

(defun dp_gds ()

  (setq dp_d1 (getpoint "\nPick a Pipe or first point :"))
  (if (/= dp_d1 nil)
    (setq ss_a1 (ssget dp_d1))
  )
  
  (cond
    ((and (/= dp_d1 nil) (/= ss_a1 nil) (setq x_list (assoc -3 (entget (ssname ss_a1 0) (list "hvac_duct")))))
     (get_base)
     (cond
       ((= d_type "RND_DUCT")
        (setq dp_dia (rtos dp_mds))
	(setq t_type "t_txt1")
        (princ (strcat "\nRound Pipe <" dp_dia ">\n"))
       )
       ((= d_type "RECT_DUCT")
	(setq dp_dia (rtos dp_mds))
	(setq dp_heg (rtos dp_mdh))
	(setq t_type "t_txt2")
	(princ (strcat "\nRectangular Pipe <" dp_dia "x" dp_heg ">\n"))
       )
     )
    )
    ((= dp_d1 nil)
     (princ "Old paramethers\n")
    )
    (T
     (setq dp_d2 (getpoint dp_d1 "\nSpecify second point :"))
     (cond
      ((= dp_d2 nil)
       (setq dp_dia dp_dia_old)
       (princ "Old paramethers\n")
      )
      ((/= dp_d2 nil)
       (setq dp_dia (rtos (distance dp_d1 dp_d2)))

       (cond
	 ((and (= t_type "t_txt1") (/= (atof dp_dia) 0.0))
	  (princ (strcat "\nRound Pipe <" dp_dia ">\n"))
	 )
	 ((and (= t_type "t_txt2") (/= (atof dp_dia) 0.0))
	  (princ (strcat "\nRectangular Pipe <" dp_dia "x" dp_heg ">\n"))
	 )
	 ((= (atof dp_dia) 0.0)
	  (setq dp_dia dp_dia_old)
	  (princ "\nImproper value! Distance must be more than 0\n")
	 )
       )
      )
     )
    )
  )
)
;================================get_rd=====================================

(defun get_rd ()
  (setq dp_d (getdist "\nSpecify first point of Pipe : "))
  (if (or (= dp_d nil) (= dp_d 0))
    (setq dp_d (atof dp_dia_old))
  )
  (setq dp_dia (rtos dp_d))
  (princ (strcat "Pipe Size <" (rtos dp_d) ">"))

  (setq dp_rad (getdist "\nSpecify first point of Radius :"))
  (if (or (= dp_rad nil) (= dp_rad 0))
    (setq dp_rad (* (atof dp_rd) dp_d))
  )
  (setq dp_dia (rtos dp_d))
  (princ (strcat "Radius <" (rtos dp_rad) ">\n"))
  
  (setq dp_red (/ dp_rad dp_d))
  (if (< dp_red  0.5)
    (progn
      (setq dp_red (atof dp_rd_old))
      (princ "\nImproper R/D value! R/D must be more than 0.5\n")
    )
  )
  (setq dp_rd (rtos dp_red))
)
;;;================================dp_img=========================================

(defun dp_img ()
    (cond
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p1")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p2")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p3")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p4")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p5")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p6")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p7")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p8")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p9")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p10")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p11")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p12")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p13")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p14")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p15")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p16")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p17")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p18")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p19")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p20")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p21")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p22")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p23")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p24")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p25")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p26")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p27")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p28")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p29")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p30")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p31")
       ))
      ((and (= de_pt "supply")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p32")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p33")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p34")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p35")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p36")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p37")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p38")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p39")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p40")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p41")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p42")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p43")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p44")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p45")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p46")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p47")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_mitered")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p48")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p49")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p50")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p51")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p52")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p53")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p54")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p55")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt1")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p56")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p57")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p58")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p59")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "1")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p60")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "1"))
       (progn
         (setq slide "dp_p61")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "1")(= dp_end "0"))
       (progn
         (setq slide "dp_p62")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "1"))
       (progn
         (setq slide "dp_p63")
       ))
      ((and (= de_pt "exhaust")(= dp_type "dp_radius")(= t_type "t_txt2")(= opt_1 "0")(= dp_text "0")(= dp_end "0"))
       (progn
         (setq slide "dp_p64")
       ))
    )
  (setq dp_slide (strcat "dp_view(" slide ")" ))
  (setq xdim (dimx_tile "dp_image"))
  (setq ydim (dimy_tile "dp_image"))
  (start_image "dp_image")
  (fill_image 0 0 xdim ydim 0)
  (slide_image 0 0 xdim ydim dp_slide)
  (end_image)
)
;======================================================

(defun sup_set ()
	(setq sup_clr (acad_colordlg sup_clr))
        (if (= sup_clr nil)
	  (setq sup_clr sup_clr_old)
	)
     (sup_img)
     (set_tile "sup_clr" (itoa sup_clr))
)
;======================================================

(defun exh_set ()
	(setq exh_clr (acad_colordlg exh_clr))
        (if (= exh_clr nil)
	  (setq exh_clr exh_clr_old)
	)
     (exh_img)
     (set_tile "exh_clr" (itoa exh_clr))
)
;======================================================

(defun scl_set ()
	(setq scl_clr (acad_colordlg scl_clr))
        (if (= scl_clr nil)
	  (setq scl_clr scl_clr_old)
	)
     (scl_img)
     (set_tile "scl_clr" (itoa scl_clr))
)
;======================================================

(defun ecl_set ()
	(setq ecl_clr (acad_colordlg ecl_clr))
        (if (= ecl_clr nil)
	  (setq ecl_clr ecl_clr_old)
	)
     (ecl_img)
     (set_tile "ecl_clr" (itoa ecl_clr))
)
;======================================================

(defun stl_set ()
	(setq stl_clr (acad_colordlg stl_clr))
        (if (= stl_clr nil)
	  (setq stl_clr stl_clr_old)
	)
     (stl_img)
     (set_tile "stl_clr" (itoa stl_clr))
)
;======================================================

(defun etl_set ()
	(setq etl_clr (acad_colordlg etl_clr))
        (if (= etl_clr nil)
	  (setq etl_clr etl_clr_old)
	)
     (etl_img)
     (set_tile "etl_clr" (itoa etl_clr))
)
;======================================================

(defun sac_set ()
	(setq sac_clr (acad_colordlg sac_clr))
        (if (= sac_clr nil)
	  (setq sac_clr sac_clr_old)
	)
     (sac_img)
     (set_tile "sac_clr" (itoa sac_clr))
)
;======================================================

(defun eac_set ()
	(setq eac_clr (acad_colordlg eac_clr))
        (if (= eac_clr nil)
	  (setq eac_clr eac_clr_old)
	)
     (eac_img)
     (set_tile "eac_clr" (itoa eac_clr))
)
;======================================================

(defun sup_img ()
 (start_image "sup_box")
   (fill_image
        0
        0
        (dimx_tile "sup_box")
        (dimy_tile "sup_box")
        sup_clr
   )
 (end_image)
)
;======================================================

(defun sup_img ()
 (start_image "sup_box")
   (fill_image
        0
        0
        (dimx_tile "sup_box")
        (dimy_tile "sup_box")
        sup_clr
   )
 (end_image)
)
;======================================================

(defun exh_img ()
 (start_image "exh_box")
   (fill_image
        0
        0
        (dimx_tile "exh_box")
        (dimy_tile "exh_box")
        exh_clr
   )
 (end_image)
)
;======================================================

(defun scl_img ()
 (start_image "scl_box")
   (fill_image
        0
        0
        (dimx_tile "scl_box")
        (dimy_tile "scl_box")
        scl_clr
   )
 (end_image)
)
;======================================================

(defun ecl_img ()
 (start_image "ecl_box")
   (fill_image
        0
        0
        (dimx_tile "ecl_box")
        (dimy_tile "ecl_box")
        ecl_clr
   )
 (end_image)
)
;======================================================

(defun stl_img ()
 (start_image "stl_box")
   (fill_image
        0
        0
        (dimx_tile "stl_box")
        (dimy_tile "stl_box")
        stl_clr
   )
 (end_image)
)
;======================================================

(defun etl_img ()
 (start_image "etl_box")
   (fill_image
        0
        0
        (dimx_tile "etl_box")
        (dimy_tile "etl_box")
        etl_clr
   )
 (end_image)
)
;======================================================

(defun sac_img ()
 (start_image "sac_box")
   (fill_image
        0
        0
        (dimx_tile "sac_box")
        (dimy_tile "sac_box")
        sac_clr
   )
 (end_image)
)
;======================================================

(defun eac_img ()
 (start_image "eac_box")
   (fill_image
        0
        0
        (dimx_tile "eac_box")
        (dimy_tile "eac_box")
        eac_clr
   )
 (end_image)
)
;;;=================================save_cfg======================================

(defun save_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (princ (strcat "\nSaving current layer settings as default..." "delbow.cfg\n"))
  (setq de_fh (open de_cfg "w"))
  (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
  (write-line "Supply Air layer:" de_fh)
  (write-line sup_lyr de_fh)
  (write-line "Supply Air layer color:" de_fh)
  (write-line (itoa sup_clr) de_fh)
  (write-line "Supply Air Center Line layer:" de_fh)
  (write-line scl_lyr de_fh)
  (write-line "Supply Air Center Line layer color:" de_fh)
  (write-line (itoa scl_clr) de_fh)
  (write-line "Supply Air Text Line layer:" de_fh)
  (write-line stl_lyr de_fh)
  (write-line "Supply Air Text Line layer color:" de_fh)
  (write-line (itoa stl_clr) de_fh)
  (write-line "Supply Air Accessories layer:" de_fh)
  (write-line sac_lyr de_fh)
  (write-line "Supply Air Accessories layer color:" de_fh)
  (write-line (itoa sac_clr) de_fh)
  (write-line "Exhaust Air layer:" de_fh)
  (write-line exh_lyr de_fh)
  (write-line "Exhaust Air layer color:" de_fh)
  (write-line (itoa exh_clr) de_fh)
  (write-line "Exhaust Air Center Line layer:" de_fh)
  (write-line ecl_lyr de_fh)
  (write-line "Exhaust Air Center Line layer color:" de_fh)
  (write-line (itoa ecl_clr) de_fh)
  (write-line "Exhaust Air Text Line layer:" de_fh)
  (write-line etl_lyr de_fh)
  (write-line "Exhaust Air Text Line layer color:" de_fh)
  (write-line (itoa etl_clr) de_fh)
  (write-line "Exhaust Air Accessories layer:" de_fh)
  (write-line eac_lyr de_fh)
  (write-line "Exhaust Air Accessories layer color:" de_fh)
  (write-line (itoa eac_clr) de_fh)
  (write-line "End of File..." de_fh) 
  (close de_fh)

  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================rest_cfg======================================

(Defun rest_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (if (= nil (findfile de_cfg))
    (progn
      (princ (strcat "\nCreating default layer settings..." "delbow.cfg\n"))
      (setq de_fh (open de_cfg "w"))
      (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
      (write-line "Supply Air layer:" de_fh)
      (write-line "HVAC-SP" de_fh)
      (write-line "Supply Air layer color:" de_fh)
      (write-line "4" de_fh)
      (write-line "Supply Air Center Line layer:" de_fh)
      (write-line "HVAC-SP-CL" de_fh)
      (write-line "Supply Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Supply Air Text Line layer:" de_fh)
      (write-line "HVAC-SP-TL" de_fh)
      (write-line "Supply Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Supply Air Accessories layer:" de_fh)
      (write-line "HVAC-SP-AC" de_fh)
      (write-line "Supply Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "Exhaust Air layer:" de_fh)
      (write-line "HVAC-EX" de_fh)
      (write-line "Exhaust Air layer color:" de_fh)
      (write-line "6" de_fh)
      (write-line "Exhaust Air Center Line layer:" de_fh)
      (write-line "HVAC-EX-CL" de_fh)
      (write-line "Exhaust Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Exhaust Air Text Line layer:" de_fh)
      (write-line "HVAC-EX-TL" de_fh)
      (write-line "Exhaust Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Exhaust Air Accessories layer:" de_fh)
      (write-line "HVAC-EX-AC" de_fh)
      (write-line "Exhaust Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "End of File..." de_fh) 
      (close de_fh)
    )
  )
  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================*error*======================================

(defun dp_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if dp_oer
    (setq *error* dp_oer)
  )
  (if plinewid_old (setvar "plinewid"  plinewid_old))
  (if old_osnap    (setvar "osmode"    old_osnap))
  (if blipmode_old (setvar "blipmode"  blipmode_old))
  (if pickbox_old  (setvar "pickbox"   pickbox_old))
  (if text_old     (setvar "textstyle" text_old))
  (if angbase_old  (setvar "angbase"   angbase_old))
  (if lay_old      (setvar "clayer"    lay_old))
  (if col_old      (setvar "cecolor"   col_old))
  (if celtype_old  (setvar "celtype"   celtype_old))
  (command "_.undo" "end")
  (if old_cmdecho  (setvar "cmdecho"   old_cmdecho))
)

(princ)
