
(defun tan (aa) (/ (sin aa) (cos aa)))
(defun dtr (bb) (/ (* pi bb) 180.0))

(defun c:dqbranch ()

  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "be")

  (setq db_oer *error* *error* db_err)

  (if (null (rest_dp))
    (rest_dp)
  )
  
  (setq old_osnap    (getvar "osmode"))
  (setq blipmode_old (getvar "blipmode"))
  (setq pickbox_old  (getvar "pickbox"))
  (setq angbase_old  (getvar "angbase"))
  (setq col_old      (getvar "cecolor"))
  (setq celtype_old  (getvar "celtype"))
  (setq lay_old      (getvar "clayer"))
  (setq plinewid_old (getvar "plinewid"))
  (setvar "plinewid" 0)
  (setvar "angbase"  0)
  (setvar "blipmode" 0)
  (setvar "pickbox"  0)
  (setvar "celtype" "bylayer")
  
  (run_dqb)
  
  (setvar "plinewid" plinewid_old)
  (setvar "angbase"  angbase_old)
  (setvar "clayer"   lay_old)
  (setvar "celtype"  celtype_old)
  (setvar "cecolor"  col_old)
  (setvar "osmode"   old_osnap)
  (setvar "blipmode" blipmode_old)
  (setvar "pickbox"   pickbox_old)
  (setq *error* db_oer)
  (command "_undo" "end")
  (setvar "cmdecho"  old_cmdecho)
  (princ)
)
;;;===============================run_db===================================

(defun run_dqb ()
  
  (if (null db_len)
    (setq db_len "50")
  )
  (if (null db_an)
    (setq db_an "90")
  )
  (if (null db_siz)
    (setq db_siz "100")
  )
  (if (null db_view)
    (setq db_view "db_left")
  )
  (if (null db_tbr)
    (setq db_tbr "1")
  )
  (if (null db_shp)
    (setq db_shp "db_tp1")
  )
  (if (null opt_1)
    (setq opt_1 "1")
  )
  (if (null db_pbp)
    (setq db_pbp "db_op1")
  )
  (if (null de_lay)
    (setq de_lay "1")
  )
  (if (null de_pt)
    (setq de_pt "supply")
  )
  (if (null dp_auto)
    (setq dp_auto "1")
  )

  (eval_de)

  (cond
    ((= db_pbp "db_op1") (get_db))
    ((= db_pbp "db_op2") (get_bb))
  )
)
;;;===============================get_db===================================

(defun get_db ()

  (check_eval)

  (setq db_l   (atof db_len)
	db_s   (atof db_siz)
	db_ang (atof db_an)
  )

  (setq db_ip (getpoint "\nInsertion point on Main Duct :"))
  (cond
    ((= db_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= db_ip nil)
     (setq db_br1 (ssget db_ip))

     (cond
       ((and (/= db_br1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname db_br1 0) (list "hvac_duct")))))
        (get_base)
        (db_aad)
       )
       (T
        (db_amd)
       )
     )
    )
  )
)
;;;===============================db_amd===================================

(defun db_amd ()
  
  (cond
    ((= db_ms nil)
     (if (or (= db_shp "db_tp1") (= opt_1 "1"))
       (progn
	 (setq db_msm (getdist db_ip "\nMain Duct size :"))
	 (if (= db_msm nil)
	   (setq db_msm 0)
	 )
	 (setq db_ms db_msm)
       )
     )
    )
    ((/= db_ms nil)
     (if (or (= db_shp "db_tp1") (= opt_1 "1"))
       (progn
	 (setq db_msm (getdist db_ip (strcat "\nMain Duct size <" (rtos db_ms) ">:")))
	 (cond
	   ((= db_msm nil)
	    (setq db_msm db_ms)
	   )
	   ((/= db_msm nil)
	    (setq db_ms db_msm)
	   )
	 )
       )
     )
    )
  )

  (setvar "osmode" 0)

  (princ "\nDirection of Main Duct :")
  
  (cond
    ((= db_view "db_right")
     (setq db_ang1 (dtr db_ang))
    )
    ((= db_view "db_left")
     (setq db_ang1 (- pi (dtr db_ang)))
    )
  )
  
  (cond
    ((= db_view "db_right")
     (setq znak     -)
     (setq znak_obr +)
    )
    ((= db_view "db_left")
     (setq znak     +)
     (setq znak_obr -)
    )
  )
  
  (cond
    ((= db_view "db_right")
     (setq db_p4 (polar db_ip 0  (/ (/ db_s 2) (sin (dtr db_ang)))))
     (setq db_p5 (polar db_ip pi (/ (/ db_s 2) (sin (dtr db_ang)))))
     (if (and (= db_shp "db_tp1") (= db_tbr "1") (or (equal db_ms db_s 1) (> db_ms db_s)))
       (progn
	 (setq db_p6 (polar db_p4 0  (/ db_l 2)))
         (setq db_p7 (polar db_p5 pi (/ db_l 2)))
         (setq db_p8 (polar db_p6 (* pi 1.5) db_ms))
         (setq db_p9 (polar db_p7 (* pi 1.5) db_ms))
       )
     )
    )
    ((= db_view "db_left")
     (setq db_p4 (polar db_ip pi (/ (/ db_s 2) (sin (dtr db_ang)))))
     (setq db_p5 (polar db_ip 0  (/ (/ db_s 2) (sin (dtr db_ang)))))
     (if (and (= db_shp "db_tp1") (= db_tbr "1") (or (equal db_ms db_s 1) (> db_ms db_s)))
       (progn
	 (setq db_p6 (polar db_p4 pi (/ db_l 2)))
         (setq db_p7 (polar db_p5 0  (/ db_l 2)))
         (setq db_p8 (polar db_p6 (* pi 1.5) db_ms))
         (setq db_p9 (polar db_p7 (* pi 1.5) db_ms))
       )
     )
    )
  )

  (setq db_p2 (polar db_p4 db_ang1 db_l))
  (setq db_p1 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) (/ db_s 2)))
  (setq db_p3 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) db_s))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (if (and (= db_shp "db_tp1") (= db_tbr "1")(or (equal db_ms db_s 1) (> db_ms db_s)))
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 db_p7 db_p9 db_p8 db_p6 db_p4 "")
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 "")
  )
  (setq db_frm (list (entlast)))

  (cond
    ((and (= db_shp "db_tp1") (not (equal db_ms db_s 1)) (> db_ms db_s))
     (setq db_ac (- db_ms (sqrt (- (expt db_ms 2.0) (expt db_s 2.0)))))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_ac 2.0) (sin (dtr db_ang)))))
     (command "_.arc" db_p5 db_p6 db_p4)
     (setq db_frm (append db_frm (list (entlast))))
    )
    ((and (= db_shp "db_tp1") (equal db_ms db_s 1))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_s 2.0) (sin (dtr db_ang)))))
     (command "_.pline" db_p5 db_p6 db_p4 "")
     (setq db_frm (append db_frm (list (entlast))))
    )
    ((= db_shp "db_tp2")
     (setq db_p6 (polar db_p1 (znak     db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (setq db_p7 (polar db_p1 (znak_obr db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (command "_.pline" db_p5 db_p1 db_p4 "")
     (setq db_frm (append db_frm (list (entlast))))
     (command "_.line"  db_p5 db_p7 "")
     (setq db_frm (append db_frm (list (entlast))))
     (command "_.line"  db_p4 db_p6 "")
     (setq db_frm (append db_frm (list (entlast))))
    )
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq db_p7 (polar db_ip (+ db_ang1 pi) (/ (/ db_ms 2) (sin (dtr db_ang)))))
      (command "_.line" db_p7 db_p1 "")
      (setq db_frm (append db_frm (list (entlast))))     
      (setq db_frd (entlast))
    )
  )

  (setq lstn (length db_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no db_frm) ss)
  )

  (setvar  "osmode" old_osnap)
  (command "_.rotate" ss "" db_ip pause)
  (setvar  "osmode" 0)

  (if (and (= db_shp "db_tp1") (/= db_br1 nil) (or (equal db_ms db_s 1) (> db_ms db_s)))
    (progn
      (setq  db_dl  (entdel db_frd))
      (command "_.trim" ss "" db_ip "")
      (entdel db_dl)
    )
  )
)
;;;===============================db_aad===================================

(defun db_aad ()

  (setvar "osmode" 0)

  (cond
    ((= db_view "db_right")
     (setq db_ang1 (+ dp_mda (+ (/ pi 2) (dtr db_ang))))
    )
    ((= db_view "db_left")
     (setq db_ang1 (- dp_mda (+ (/ pi 2) (dtr db_ang))))
    )
  )
  
  (cond
    ((= db_view "db_right")
     (setq znak     -)
     (setq znak_obr +)
    )
    ((= db_view "db_left")
     (setq znak     +)
     (setq znak_obr -)
    )
  )
  
  (cond
    ((= db_view "db_right")
     (setq db_p4 (polar db_ip (+ dp_mda (/ pi 2)) (/ (/ db_s 2) (sin (dtr db_ang)))))
     (setq db_p5 (polar db_ip (- dp_mda (/ pi 2)) (/ (/ db_s 2) (sin (dtr db_ang)))))
     (if (and (= db_shp "db_tp1") (= d_type "RND_DUCT") (= db_tbr "1") (>= dp_mds db_s))
       (progn
	 (setq db_p6 (polar db_p4 (+ dp_mda (/ pi 2)) (/ db_l 2)))
         (setq db_p7 (polar db_p5 (- dp_mda (/ pi 2)) (/ db_l 2)))
         (setq db_p8 (polar db_p6 dp_mda dp_mds))
         (setq db_p9 (polar db_p7 dp_mda dp_mds))
       )
     )
    )
    ((= db_view "db_left")
     (setq db_p4 (polar db_ip (- dp_mda (/ pi 2)) (/ (/ db_s 2) (sin (dtr db_ang)))))
     (setq db_p5 (polar db_ip (+ dp_mda (/ pi 2)) (/ (/ db_s 2) (sin (dtr db_ang)))))
     (if (and (= db_shp "db_tp1") (= d_type "RND_DUCT") (= db_tbr "1") (>= dp_mds db_s))
       (progn
	 (setq db_p6 (polar db_p4 (- dp_mda (/ pi 2)) (/ db_l 2)))
         (setq db_p7 (polar db_p5 (+ dp_mda (/ pi 2)) (/ db_l 2)))
         (setq db_p8 (polar db_p6 dp_mda dp_mds))
         (setq db_p9 (polar db_p7 dp_mda dp_mds))
       )
     )
    )
  )

  (setq db_b1 (ssget db_p4))
  (setq db_b2 (ssget db_p5))

  (if (and (= db_shp "db_tp1") (= d_type "RND_DUCT") (/= db_b1 nil) (/= db_b2 nil) (>= dp_mds db_s))
    (command "_.break" db_p4 db_p5)
  )
  
  (setq db_p2 (polar db_p4 db_ang1 db_l))
  (setq db_p1 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) (/ db_s 2)))
  (setq db_p3 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) db_s))

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (if (and (= db_shp "db_tp1") (= d_type "RND_DUCT") (= db_tbr "1") (>= dp_mds db_s))
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 db_p7 db_p9 db_p8 db_p6 db_p4 "")
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 "")
  )

  (cond
    ((and (= db_shp "db_tp1") (= d_type "RND_DUCT") (not (equal dp_mds db_s 1)) (> dp_mds db_s))
     (setq db_ac (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt db_s 2.0)))))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_ac 2.0) (sin (dtr db_ang)))))
     (command "_.arc" db_p5 db_p6 db_p4)
    )
    ((and (= db_shp "db_tp1") (= d_type "RND_DUCT") (equal dp_mds db_s 1))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_s 2.0) (sin (dtr db_ang)))))
     (command "_.pline" db_p5 db_p6 db_p4 "")
    )
    ((or (= db_shp "db_tp2") (and (= db_shp "db_tp1") (= d_type "RECT_DUCT")))
     (setq db_p6 (polar db_p1 (znak     db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (setq db_p7 (polar db_p1 (znak_obr db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (command "_.pline" db_p5 db_p1 db_p4 "")
     (command "_.line"  db_p5 db_p7 "")
     (command "_.line"  db_p4 db_p6 "")
    )
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq db_p7 (polar db_ip (+ db_ang1 pi) (/ (/ dp_mds 2) (sin (dtr db_ang)))))
      (command "_.line" db_p7 db_p1 "")
    )
  )
  (setq db_ms dp_mds)
)
;;;=================================get_bb======================================

(defun get_bb ()

  (check_eval)

  (setq db_l (atof db_len)
	db_s (atof db_siz) 
  )

  (setvar "cmdecho" 0)

  (setq db_a1 (getpoint "\nPoint on Main Duct :"))

  (cond
    ((= db_a1 nil)
     (princ "\nFunction cancelled!")
    )
    ((/= db_a1 nil)
     (setq db_ar1 (ssget db_a1))
     (cond
       ((and (/= db_ar1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname db_ar1 0) (list "hvac_duct")))))
        (get_base)
        (get_angle)
        (db_abb)
       )
       (T
        (db_bbb)
       )
     )
    )
  )
)
;;;=================================db_bbb======================================

(defun db_bbb ()

  (initget 1)
  (setq db_ip (getpoint db_a1 "\nInsertion point on Main Duct  :"))
  
  (grdraw db_a1 db_ip -1 0)

  (initget 1)
  (setq db_a3  (getpoint db_ip "\nDirection point of Branch :"))

  (setq db_an1 (angle db_ip db_a1)
        db_an2 (angle db_ip db_a3)
        db_an3 (- db_an1 db_an2)
  )

  (if (< db_an3 0) (setq db_an3 (+ (* pi 2) db_an3)))
  
  (cond
    ((and (> db_an3 0) (<= db_an3 (/ pi 2)))
       (setq znak     +
             znak_obr -
	     db_ang db_an3
       )
    )
    ((and (> db_an3 (/ pi 2)) (< db_an3 pi))
       (setq znak     -
             znak_obr +
	     db_ang (- pi db_an3)
       )
    )
    ((and (> db_an3 pi) (<= db_an3 (* pi 1.5)))   
       (setq znak     +
             znak_obr -
	     db_ang (- db_an3 pi)
       )
    )
    ((and (> db_an3 (* pi 1.5)) (< db_an3 (* pi 2)))   
       (setq znak     -
             znak_obr +
	     db_ang (- (* pi 2) db_an3)
       )
    )
  )
  
  (cond
    ((and (/= db_an3 0) (/= db_an3 pi))
     (redraw)
     (db_bbs)
    )
    ((or (= db_an3 0) (= db_an3 pi))
     (redraw)
     (princ "\nAngle must be more than 0 and less than 180 degrees")
    )
  )
)
;;;=================================db_bbs======================================

(defun db_bbs ()

  (setq db_br1 (ssget db_ip))
    
  (cond
    ((= db_ms nil)
     (if (or (= db_shp "db_tp1") (= opt_1 "1"))
       (progn
	 (setq db_msm (getdist db_ip "\nMain Duct size :"))
	 (if (= db_msm nil)
	   (setq db_msm 0)
	 )
	 (setq db_ms db_msm)
       )
     )
    )
    ((/= db_ms nil)
     (if (or (= db_shp "db_tp1") (= opt_1 "1"))
       (progn
	 (setq db_msm (getdist db_ip (strcat "\nMain Duct size <" (rtos db_ms) ">:")))
	 (cond
	   ((= db_msm nil)
	    (setq db_msm db_ms)
	   )
	   ((/= db_msm nil)
	    (setq db_ms db_msm)
	   )
	 )
       )
     )
    )
  )

  (setvar "osmode" 0)
  
  (setq db_ang1 db_an2)

  (cond
    ((or (and (> db_an3 (/ pi 2)) (< db_an3 pi)) (and (> db_an3 pi) (<= db_an3 (* pi 1.5))))
     (setq db_p4 (polar db_ip (+ db_an1 pi) (/ (/ db_s 2) (sin db_ang))))
     (setq db_p5 (polar db_ip db_an1        (/ (/ db_s 2) (sin db_ang))))
     (if (and (= db_shp "db_tp1") (= db_tbr "1") (or (equal db_ms db_s 1) (> db_ms db_s)))
       (progn
         (setq db_p6 (polar db_p4 (+ db_an1 pi) (/ db_l 2)))
         (setq db_p7 (polar db_p5 db_an1        (/ db_l 2)))
         (setq db_p8 (polar db_p6 (znak_obr db_an1 (/ pi 2)) db_ms))
         (setq db_p9 (polar db_p7 (znak_obr db_an1 (/ pi 2)) db_ms))
       )
     )
    )
    ((or (and (> db_an3 0) (<= db_an3 (/ pi 2))) (and (> db_an3 (* pi 1.5)) (< db_an3 (* pi 2))))
     (setq db_p4 (polar db_ip db_an1        (/ (/ db_s 2) (sin db_ang))))
     (setq db_p5 (polar db_ip (+ db_an1 pi) (/ (/ db_s 2) (sin db_ang))))
     (if (and (= db_shp "db_tp1") (= db_tbr "1") (or (equal db_ms db_s 1) (> db_ms db_s)))
       (progn
         (setq db_p6 (polar db_p4 db_an1        (/ db_l 2)))
         (setq db_p7 (polar db_p5 (+ db_an1 pi) (/ db_l 2)))
         (setq db_p8 (polar db_p6 (znak db_an1 (/ pi 2)) db_ms))
         (setq db_p9 (polar db_p7 (znak db_an1 (/ pi 2)) db_ms))
       )
     )
    )
  )

  (setq db_p2 (polar db_p4 db_ang1 db_l))
  (setq db_p1 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) (/ db_s 2)))
  (setq db_p3 (polar db_p2 (znak_obr db_ang1 (/ pi 2)) db_s))

  (setq db_br2 (ssget db_p4))
  (setq db_br3 (ssget db_p5))
  
  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )

  (if (and (= db_shp "db_tp1") (/= db_br1 nil) (/= db_br2 nil) (/= db_br3 nil) (or (equal db_ms db_s 1) (> db_ms db_s)))
    (command "_.break" db_p4 db_p5)
  )
  
  (if (and (= db_shp "db_tp1") (= db_tbr "1") (or (equal db_ms db_s 1) (> db_ms db_s)))
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 db_p7 db_p9 db_p8 db_p6 db_p4 "")
    (command "_.pline" db_p4 db_p2 db_p3 db_p5 "")
  )

  (cond
    ((and (= db_shp "db_tp1") (not (equal db_ms db_s 1)) (> db_ms db_s))
     (setq db_ac (- db_ms (sqrt (- (expt db_ms 2.0) (expt db_s 2.0)))))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_ac 2.0) (sin db_ang))))
     (command "_.arc" db_p5 db_p6 db_p4)
    )
    ((and (= db_shp "db_tp1") (equal db_ms db_s 1))
     (setq db_p6 (polar db_ip (+ db_ang1 pi) (/ (/ db_s 2.0) (sin db_ang))))
     (command "_.pline" db_p5 db_p6 db_p4 "")
    )
    ((= db_shp "db_tp2")
     (setq db_p6 (polar db_p1 (znak     db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (setq db_p7 (polar db_p1 (znak_obr db_ang1 (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
     (command "_.pline" db_p5 db_p1 db_p4 "")
     (command "_.line"  db_p5 db_p7 "")
     (command "_.line"  db_p4 db_p6 "")
    )
  )

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (setq db_p7 (polar db_ip (+ db_ang1 pi) (/ (/ db_ms 2) (sin db_ang))))
      (command "_.line" db_p7 db_p1 "")
    )
  )
)
;;;=================================db_abb======================================

(defun db_abb ()

  (setq db_a2 (getpoint db_a1 "\nDirection of branch :"))

  (setq dp_anb (angle db_a1 db_a2))

  (if (and (> (abs (- dp_anb dp_mda)) (/ pi 2)) (< (abs (- dp_anb dp_mda)) (* (/ pi 2) 3)))
    (progn
      
      (setvar "osmode" 0)
      
      (cond
	((<= (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (- (abs (- dp_anb dp_mda)) (/ pi 2)))
	 (setq znak     +)
	 (setq znak_obr -)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     -)
	     (setq znak_obr +)
	   )
	 )
	 (setq db_b1  (polar db_a1 (znak     dp_mda (/ pi 2)) (/ (/ db_s 2) (sin db_anm))))
         (setq db_b2  (polar db_a1 (znak_obr dp_mda (/ pi 2)) (/ (/ db_s 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb db_l))
         (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) db_s))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ db_s 2)))
	)
	((> (abs (- dp_anb dp_mda)) pi)
	 (setq db_anm (abs (- (+ dp_mda (* (/ pi 2) 3)) dp_anb)))
	 (setq znak     -)
	 (setq znak_obr +)
	 (if (minusp (- dp_anb dp_mda))
	   (progn
	     (setq znak     +)
	     (setq znak_obr -)
	   )
	 )
	 (setq db_b1  (polar db_a1 (znak     dp_mda (/ pi 2)) (/ (/ db_s 2) (sin db_anm))))
         (setq db_b2  (polar db_a1 (znak_obr dp_mda (/ pi 2)) (/ (/ db_s 2) (sin db_anm))))
	 (setq db_b3  (polar db_b1 dp_anb db_l))
	 (setq db_b4  (polar db_b3 (znak dp_anb (/ pi 2)) db_s))
         (setq db_b5  (polar db_b3 (znak dp_anb (/ pi 2)) (/ db_s 2)))
	)
      )

      (setq db_br1 (ssget db_b1))
      (setq db_br2 (ssget db_b2))

      (if (and (= d_type "RND_DUCT") (= db_shp "db_tp1") (/= db_br1 nil) (/= db_br2 nil) (>= dp_mds db_s))
	(command "_.break" db_b1 db_b2)
      )

      (if (= opt_1 "1")
        (progn
          (if (= de_lay "1")
            (progn
              (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	      (command "_.color" cl_clr)
            )
          )
          (setq db_b7 (polar db_a1 (+ dp_anb pi) (/ (/ dp_mds 2) (sin db_anm))))
          (command "_.line" db_b7 db_b5 "")
        )
      )

      (if (= de_lay "1")
        (progn
          (command "_.layer" "_m" vp_lyr "_s" vp_lyr "")
          (command "_.color" vp_clr)
        )
      )

      (cond
        ((and (= d_type "RND_DUCT") (= db_shp "db_tp1") (not (equal dp_mds db_s 1)) (> dp_mds db_s))
         (setq db_acp (- dp_mds (sqrt (- (expt dp_mds 2.0) (expt db_s 2.0)))))
         (setq db_b6 (polar db_a1 (+ dp_anb pi) (/ (/ db_acp 2.0) (sin db_anm))))
         (command "_.arc" db_b1 db_b6 db_b2)
        )
        ((and (= d_type "RND_DUCT") (= db_shp "db_tp1") (equal dp_mds db_s 1))
         (setq db_b6 (polar db_a1 (+ dp_anb pi) (/ (/ dp_mds 2.0) (sin db_anm))))
         (command "_.pline" db_b1 db_b6 db_b2 "")
        )
	((or (= db_shp "db_tp2") (and (= db_shp "db_tp1") (= d_type "RECT_DUCT")))
	 (setq db_b6 (polar db_b5 (znak     dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
         (setq db_b7 (polar db_b5 (znak_obr dp_anb (/ pi 2)) (* (sin (/ pi 4)) (/ db_s 2.0))))
	 (command "_.pline" db_b1 db_b5 db_b2 "")
         (command "_.line"  db_b1 db_b7 "")
         (command "_.line"  db_b2 db_b6 "")
        )
      )

      (if (and (= d_type "RND_DUCT") (= db_shp "db_tp1") (>= dp_mds db_s) (= db_tbr "1"))
	(progn
	  (setq db_b8  (polar db_b1 (znak     dp_mda (/ pi 2)) (/ db_l 2)))
	  (setq db_b9  (polar db_b2 (znak_obr dp_mda (/ pi 2)) (/ db_l 2)))
	  (setq db_b10 (polar db_b8 dp_mda dp_mds))
	  (setq db_b11 (polar db_b9 dp_mda dp_mds))
	  (command "_.pline" db_b1 db_b3 db_b4 db_b2 db_b9 db_b11 db_b10 db_b8 db_b1 "")
	)
        (command "_.pline" db_b1 db_b3 db_b4 db_b2 "")
      )
    )
    (princ "\nAngle must be more than 0 and less than 180 degrees")
  )
)
;================================get_base=====================================

(defun get_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
    )
  )
)
;================================get_angle=====================================

(defun get_angle ()
  
  (if (and dp_mda (= de_polar "1"))
    (progn
      (setq ab_mda (+ dp_mda pi))
      (setvar "angbase" ab_mda)
    )
  )
)
;================================eval_de=====================================

(defun eval_de ()
  (cond
    ((= de_pt "supply")
       (progn
         (setq vp_lyr sup_lyr)
         (setq cl_lyr scl_lyr)
         (setq tl_lyr stl_lyr)
	 (setq ac_lyr sac_lyr)
         (setq vp_clr sup_clr)
         (setq cl_clr scl_clr)
         (setq tl_clr stl_clr)
	 (setq ac_clr sac_clr)
       )
    )
    ((= de_pt "exhaust")
       (progn
         (setq vp_lyr exh_lyr)
         (setq cl_lyr ecl_lyr)
         (setq tl_lyr etl_lyr)
	 (setq ac_lyr eac_lyr)
         (setq vp_clr exh_clr)
         (setq cl_clr ecl_clr)
         (setq tl_clr etl_clr)
	 (setq ac_clr eac_clr)
       )
    )
  )
)
;==================================check_eval=====================================

(defun check_eval ()

  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" vp_lyr))) 0)
      (progn
        (setq vp_st  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rh  (assoc 70 vp_st))
        (setq vp_nch (cons 70 0))
        (setq vp_nst (subst vp_nch vp_rh vp_st))
        (entmod vp_nst)
      )
    )
  )
  
  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" vp_lyr))) 7)
      (progn
        (setq vp_ft  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rf  (assoc 62 vp_ft))
        (setq vp_ncf (cons 62 7))
        (setq vp_fst (subst vp_ncf vp_rf vp_ft))
        (entmod vp_fst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" cl_lyr))) 0)
      (progn
        (setq cl_st  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rh  (assoc 70 cl_st))
        (setq cl_nch (cons 70 0))
        (setq cl_nst (subst cl_nch cl_rh cl_st))
        (entmod cl_nst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" cl_lyr))) 7)
      (progn
        (setq cl_ft  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rf  (assoc 62 cl_ft))
        (setq cl_ncf (cons 62 7))
        (setq cl_fst (subst cl_ncf cl_rf cl_ft))
        (entmod cl_fst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" tl_lyr))) 0)
      (progn
        (setq tl_st  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rh  (assoc 70 tl_st))
        (setq tl_nch (cons 70 0))
        (setq tl_nst (subst tl_nch tl_rh tl_st))
        (entmod tl_nst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" tl_lyr))) 7)
      (progn
        (setq tl_ft  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rf  (assoc 62 tl_ft))
        (setq tl_ncf (cons 62 7))
        (setq tl_fst (subst tl_ncf tl_rf tl_ft))
        (entmod tl_fst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" ac_lyr))) 0)
      (progn
        (setq ac_st  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rh  (assoc 70 ac_st))
        (setq ac_nch (cons 70 0))
        (setq ac_nst (subst ac_nch ac_rh ac_st))
        (entmod ac_nst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" ac_lyr))) 7)
      (progn
        (setq ac_ft  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rf  (assoc 62 ac_ft))
        (setq ac_ncf (cons 62 7))
        (setq ac_fst (subst ac_ncf ac_rf ac_ft))
        (entmod ac_fst)
      )
    )
  )
)
;;;=============================rest_db_cfg===================================

(Defun rest_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (if (= nil (findfile de_cfg))
    (progn
      (princ (strcat "\nCreating default layer settings..." "delbow.cfg\n"))
      (setq de_fh (open de_cfg "w"))
      (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
      (write-line "Supply Air layer:" de_fh)
      (write-line "HVAC-SP" de_fh)
      (write-line "Supply Air layer color:" de_fh)
      (write-line "4" de_fh)
      (write-line "Supply Air Center Line layer:" de_fh)
      (write-line "HVAC-SP-CL" de_fh)
      (write-line "Supply Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Supply Air Text Line layer:" de_fh)
      (write-line "HVAC-SP-TL" de_fh)
      (write-line "Supply Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Supply Air Accessories layer:" de_fh)
      (write-line sac_lyr de_fh)
      (write-line "Supply Air Accessories layer color:" de_fh)
      (write-line (itoa sac_clr) de_fh)
      (write-line "Exhaust Air layer:" de_fh)
      (write-line "HVAC-VT" de_fh)
      (write-line "Exhaust Air layer color:" de_fh)
      (write-line "6" de_fh)
      (write-line "Exhaust Air Center Line layer:" de_fh)
      (write-line "HVAC-VT-CL" de_fh)
      (write-line "Exhaust Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Exhaust Air Text Line layer:" de_fh)
      (write-line "HVAC-VT-TL" de_fh)
      (write-line "Exhaust Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Exhaust Air Accessories layer:" de_fh)
      (write-line eac_lyr de_fh)
      (write-line "Exhaust Air Accessories layer color:" de_fh)
      (write-line (itoa eac_clr) de_fh)
      (write-line "End of File..." de_fh) 
      (close de_fh)
    )
  )
  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================*error*======================================

(defun db_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if db_oer
    (setq *error* db_oer)
  )
  (if plinewid_old (setvar "plinewid" plinewid_old))
  (if old_osnap    (setvar "osmode"   old_osnap))
  (if blipmode_old (setvar "blipmode" blipmode_old))
  (if pickbox_old  (setvar "pickbox"   pickbox_old))
  (if angbase_old  (setvar "angbase"  angbase_old))
  (if lay_old      (setvar "clayer"   lay_old))
  (if col_old      (setvar "cecolor"  col_old))
  (if celtype_old  (setvar "celtype"  celtype_old))
  (redraw)
  (command "_.undo" "end")
  (if old_cmdecho  (setvar "cmdecho"  old_cmdecho))
)

(princ)