
(defun tan (aa) (/ (sin aa) (cos aa)))
(defun dtr (bb) (/ (* pi bb) 180.0))

(defun c:dqtransform ()

  (setq old_cmdecho  (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "be")

  (setq dt_oer *error* *error* dt_err)

  (if (null (rest_dp))
    (rest_dp)
  )

  (setq dt_del nil)
  
  (setq old_osnap    (getvar "osmode"))
  (setq blipmode_old (getvar "blipmode"))
  (setq pickbox_old  (getvar "pickbox"))
  (setq angbase_old  (getvar "angbase"))
  (setq col_old      (getvar "cecolor"))
  (setq celtype_old  (getvar "celtype"))
  (setq lay_old      (getvar "clayer"))
  (setq plinewid_old (getvar "plinewid"))
  (setvar "plinewid" 0)
  (setvar "angbase"  0)
  (setvar "blipmode" 0)
  (setvar "pickbox"  0)
  (setvar "celtype" "bylayer")
  
  (run_dqt)
  
  (unload_dialog dcl_id)
  (setvar "plinewid" plinewid_old)
  (setvar "angbase"  angbase_old)
  (setvar "clayer"   lay_old)
  (setvar "cecolor"  col_old)
  (setvar "celtype"  celtype_old)
  (setvar "osmode"   old_osnap)
  (setvar "blipmode" blipmode_old)
  (setvar "pickbox"   pickbox_old)
  (setq *error* dt_oer)
  (command "_.undo" "end")
  (setvar "cmdecho"  old_cmdecho)
  (princ)
)
;;;=============================run_dt=================================

(defun run_dqt ()

  (if (null dt_shp)
    (setq dt_shp "rec_2")
  )
  (if (null dt_typ)
    (setq dt_typ "dt_tp2")
  )
  (if (null dt_view)
    (setq dt_view "dt_right")
  )
  (if (null dt_s1)
    (setq dt_s1 "160")
  )
  (if (null dt_s2)
    (setq dt_s2 "100")
  )
  (if (null dt_l)
    (setq dt_l "100")
  )
  (if (null dt_lt)
    (setq dt_lt "dt_len")
  )
  (if (null dt_an)
    (setq dt_an "60")
  )
  (if (null opt_1)
    (setq opt_1 "1")
  )
  (if (null de_lay)
    (setq de_lay "1")
  )
  (if (null de_pt)
    (setq de_pt "supply")
  )
  (if (null dp_auto)
    (setq dp_auto "1")
  )

  (eval_de)

  (get_dt)
)
;;;=============================get_dt===================================

(defun get_dt ()

  (check_eval)
  
  (setq s1  (atof dt_s1)
        s2  (atof dt_s2)
        dtl (atof dt_l)
	dta (atof dt_an)
  )

  (setq dt_ip (getpoint "\nInsertion point (Size 1) :"))

  (cond
    ((= dt_ip nil)
     (princ "\nFunction cancelled!")
    )
    ((/= dt_ip nil)
     (setq dt_ar1 (ssget dt_ip))

     (cond
       ((and (/= dt_ar1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dt_ar1 0) (list "hvac_duct")))))
        (get_base)
        (dt_apd)
       )
       ((and (/= dt_ar1 nil) (= dp_auto "1") (setq x_list (assoc -3 (entget (ssname dt_ar1 0) (list "hvac_end")))))
	(get_end_base)
	(dt_adp)
       )
       (T
	(dt_mdp)
       )
     )
    )
  )
)
;;;=============================dt_mdp===================================

(defun dt_mdp ()
  
  (setq dt_p1 (polar dt_ip (dtr 90.0)  (/ s1 2))
	dt_p2 (polar dt_ip (dtr 270.0) (/ s1 2))
  )
  
  (setq dt_ds (- (/ s1 2) (/ s2 2)))

  (princ "\nDirection of Duct :")
  
  (cond
    ((and (= dt_lt "dt_ang")(or (= dt_typ "dt_tp1")(= dt_typ "dt_tp3")))
     (setq dtl (* (abs (tan (dtr dta))) (* (abs dt_ds) 2)))
    )
    ((and (= dt_lt "dt_ang")(= dt_typ "dt_tp2"))
     (setq dtl (* (abs (tan (dtr dta))) (abs dt_ds)))
    )
  )

  (cond
    ((= dt_view "dt_left")
     (setq dt_p3 (polar dt_ip (dtr 0.0) dtl))
    )
    ((= dt_view "dt_right")
     (setq dt_p3 (polar dt_ip (dtr 180.0) dtl))
    )
  )

  (cond
    ((= dt_typ "dt_tp1")
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (dtr 90.0)  (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (dtr 270.0) (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
    ((= dt_typ "dt_tp2")
     (setq dt_p4 dt_p3)
    )
    ((= dt_typ "dt_tp3")
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (dtr 270.0) (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (dtr 90.0)  (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
  )
  
  (setq dt_p5 (polar dt_p4 (dtr 90.0) (/ s2 2))
	dt_p6 (polar dt_p4 (dtr 270.0) (/ s2 2))
  )

  (setq dt_s3 (* (sin (dtr 45)) (/ s1 2))
	dt_s4 (* (sin (dtr 45)) (/ s2 2))
  )

  (setq dt_p7  (polar dt_p4 (dtr 90.0)  dt_s4)
	dt_p8  (polar dt_p4 (dtr 270.0) dt_s4)
	dt_p9  (polar dt_ip (dtr 90.0)  dt_s3)
	dt_p10 (polar dt_ip (dtr 270.0) dt_s3)
  )

  (setvar "osmode" 0)
  
  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (command "_.pline" dt_p1 dt_p2 dt_p6 dt_p5 "c")
  (setq dt_frm (list (entlast)))

  (cond
    ((= dt_shp "rec_3")
     (command "_.pline" dt_p5 dt_ip dt_p6 "")
     (setq dt_frm (append dt_frm (list (entlast))))
     (command "_.line" dt_p10 dt_p6 "")
     (setq dt_frm (append dt_frm (list (entlast))))
     (command "_.line" dt_p9 dt_p5 "")
     (setq dt_frm (append dt_frm (list (entlast))))
    )
    ((= dt_shp "rec_4")
     (command "_.pline" dt_p1 dt_p4 dt_p2 "")
     (setq dt_frm (append dt_frm (list (entlast))))
     (command "_.line" dt_p8 dt_p2 "")
     (setq dt_frm (append dt_frm (list (entlast))))
     (command "_.line" dt_p7 dt_p1 "")
     (setq dt_frm (append dt_frm (list (entlast))))
    )
  )     

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" dt_ip dt_p4 "")
      (setq dt_frm (append dt_frm (list (entlast))))
    )
  )

  (setq lstn (length dt_frm))
  (setq no -1)
  (setq ss (ssadd))
  (repeat lstn
    (setq no (1+ no))
    (ssadd (nth no dt_frm) ss)
  )

  (setvar "osmode" old_osnap)

  (if (= dt_view "dt_left")
    (setvar "angbase" (dtr 180.0))
  )
 
  (command "_.rotate" ss "" dt_ip pause)
)
;;;=============================dt_adp===================================

(defun dt_adp ()

  (setvar "osmode" 0)

  (entdel (ssname dt_ar1 0))

  (setq dt_anb (+ dp_mda pi))

  (setq dt_p1 (polar dp_e1 (- dt_anb (/ pi 2)) (/ dp_mds 2))
	dt_p2 (polar dp_e1 (+ dt_anb (/ pi 2)) (/ dp_mds 2))
  )
  
  (setq dt_ds (- (/ dp_mds 2) (/ s2 2)))
  
  (cond
    ((and (= dt_lt "dt_ang")(or (= dt_typ "dt_tp1")(= dt_typ "dt_tp3")))
     (setq dtl (* (abs (tan (dtr dta))) (* (abs dt_ds) 2)))
    )
    ((and (= dt_lt "dt_ang")(= dt_typ "dt_tp2"))
     (setq dtl (* (abs (tan (dtr dta))) (abs dt_ds)))
    )
  )
  
  (setq dt_p3 (polar dp_e1 dt_anb dtl))

  (cond
    ((or (and (= dt_typ "dt_tp1") (or (<= dp_mda (/ pi 2)) (> dp_mda (* pi 1.5)))) (and (= dt_typ "dt_tp3") (and (> dp_mda (/ pi 2)) (<= dp_mda (* pi 1.5)))))
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (- dt_anb (/ pi 2)) (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (+ dt_anb (/ pi 2)) (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
    ((= dt_typ "dt_tp2")
     (setq dt_p4 dt_p3)
    )
    ((or (and (= dt_typ "dt_tp1") (and (> dp_mda (/ pi 2)) (<= dp_mda (* pi 1.5)))) (and (= dt_typ "dt_tp3") (or (<= dp_mda (/ pi 2)) (> dp_mda (* pi 1.5)))))
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (+ dt_anb (/ pi 2)) (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (- dt_anb (/ pi 2)) (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
  )
  
  (setq dt_p5 (polar dt_p4 (- dt_anb (/ pi 2)) (/ s2 2))
	dt_p6 (polar dt_p4 (+ dt_anb (/ pi 2)) (/ s2 2))
  )

  (setq dt_s3 (* (sin (dtr 45)) (/ dp_mds 2))
	dt_s4 (* (sin (dtr 45)) (/ s2 2))
  )

  (setq dt_p7  (polar dt_p4 (- dt_anb (/ pi 2)) dt_s4)
	dt_p8  (polar dt_p4 (+ dt_anb (/ pi 2)) dt_s4)
	dt_p9  (polar dp_e1 (- dt_anb (/ pi 2)) dt_s3)
	dt_p10 (polar dp_e1 (+ dt_anb (/ pi 2)) dt_s3)
  )

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (command "_.pline" dt_p1 dt_p2 dt_p6 dt_p5 "c")

  (cond
    ((and (or (= dt_shp "rec_1") (= dt_shp "rec_3")) (= d_type "RND_DUCT"))
     (command "_.pline" dt_p5 dp_e1 dt_p6 "")
     (command "_.line" dt_p10 dt_p6 "")
     (command "_.line" dt_p9 dt_p5 "")
    )
    ((and (or (= dt_shp "rec_2") (= dt_shp "rec_4")) (= d_type "RECT_DUCT"))
     (command "_.pline" dt_p1 dt_p4 dt_p2 "")
     (command "_.line" dt_p8 dt_p2 "")
     (command "_.line" dt_p7 dt_p1 "")
    )
  )     

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" dp_e1 dt_p4 "")
    )
  )
)
;;;=============================dt_apd===================================

(defun dt_apd ()

  (setvar "osmode" 0)

  (setq dt_mdl (entget (ssname dt_ar1 0)))
  (setq dt_msp (cdr (assoc 10 dt_mdl)))
  (setq dt_mep (cdr (assoc 11 dt_mdl)))
  (setq dt_dsp (distance dt_ip dt_msp))
  (setq dt_dtp (distance dt_ip dt_mep))

  (cond
    ((<= dt_dsp dt_dtp)
     (setq dt_anb (angle dt_mep dt_msp))
     (setq dt_ip (polar dt_msp dp_mda (/ dp_mds 2.0)))
    )
    ((< dt_dtp dt_dsp)
     (setq dt_anb (angle dt_msp dt_mep))
     (setq dt_ip (polar dt_mep dp_mda (/ dp_mds 2.0)))
    )
  )

  (setq dt_ept (polar dt_ip dp_mda (/ dp_mds 4.0)))
  (setq dt_er1 (ssget dt_ept))

  (setq dt_p1 (polar dt_ip (- dt_anb (/ pi 2)) (/ dp_mds 2))
	dt_p2 (polar dt_ip (+ dt_anb (/ pi 2)) (/ dp_mds 2))
  )
  
  (setq dt_ds (- (/ dp_mds 2) (/ s2 2)))
  
  (cond
    ((and (= dt_lt "dt_ang")(or (= dt_typ "dt_tp1")(= dt_typ "dt_tp3")))
     (setq dtl (* (abs (tan (dtr dta))) (* (abs dt_ds) 2)))
    )
    ((and (= dt_lt "dt_ang")(= dt_typ "dt_tp2"))
     (setq dtl (* (abs (tan (dtr dta))) (abs dt_ds)))
    )
  )
  
  (setq dt_p3 (polar dt_ip dt_anb dtl))

  (cond
    ((or (and (= dt_typ "dt_tp3") (or (<= dt_anb (/ pi 2)) (> dt_anb (* pi 1.5)))) (and (= dt_typ "dt_tp1") (and (> dt_anb (/ pi 2)) (<= dt_anb (* pi 1.5)))))
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (- dt_anb (/ pi 2)) (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (+ dt_anb (/ pi 2)) (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
    ((= dt_typ "dt_tp2")
     (setq dt_p4 dt_p3)
    )
    ((or (and (= dt_typ "dt_tp3") (and (> dt_anb (/ pi 2)) (<= dt_anb (* pi 1.5)))) (and (= dt_typ "dt_tp1") (or (<= dt_anb (/ pi 2)) (> dt_anb (* pi 1.5)))))
     (cond
       ((> dt_ds 0)(setq dt_p4 (polar dt_p3 (+ dt_anb (/ pi 2)) (abs dt_ds))))
       ((< dt_ds 0)(setq dt_p4 (polar dt_p3 (- dt_anb (/ pi 2)) (abs dt_ds))))
       ((= dt_ds 0)(setq dt_p4 dt_p3))
     )
    )
  )
  
  (setq dt_p5 (polar dt_p4 (- dt_anb (/ pi 2)) (/ s2 2))
	dt_p6 (polar dt_p4 (+ dt_anb (/ pi 2)) (/ s2 2))
  )

  (setq dt_s3 (* (sin (dtr 45)) (/ dp_mds 2))
	dt_s4 (* (sin (dtr 45)) (/ s2 2))
  )

  (setq dt_p7  (polar dt_p4 (- dt_anb (/ pi 2)) dt_s4)
	dt_p8  (polar dt_p4 (+ dt_anb (/ pi 2)) dt_s4)
	dt_p9  (polar dt_ip (- dt_anb (/ pi 2)) dt_s3)
	dt_p10 (polar dt_ip (+ dt_anb (/ pi 2)) dt_s3)
  )

  (if (and (/= dt_er1 nil) (setq x_list (assoc -3 (entget (ssname dt_er1 0) (list "hvac_end")))))
    (setq dt_del (entdel (cdr (assoc -1 (entget (ssname dt_er1 0))))))
  )

  (if (= de_lay "1")
    (progn
      (command "_.layer" "m" vp_lyr "s" vp_lyr "")
      (command "_.color" vp_clr)
    )
  )
  
  (command "_.pline" dt_p1 dt_p2 dt_p6 dt_p5 "c")

  (cond
    ((and (or (= dt_shp "rec_1") (= dt_shp "rec_3")) (= d_type "RND_DUCT"))
     (command "_.pline" dt_p5 dt_ip dt_p6 "")
     (command "_.line" dt_p10 dt_p6 "")
     (command "_.line" dt_p9 dt_p5 "")
    )
    ((and (or (= dt_shp "rec_2") (= dt_shp "rec_4")) (= d_type "RECT_DUCT"))
     (command "_.pline" dt_p1 dt_p4 dt_p2 "")
     (command "_.line" dt_p8 dt_p2 "")
     (command "_.line" dt_p7 dt_p1 "")
    )
  )     

  (if (= opt_1 "1")
    (progn
      (if (= de_lay "1")
        (progn
          (command "_.layer" "m" cl_lyr "l" "center" cl_lyr "")
	  (command "_.color" cl_clr)
        )
      )
      (command "_.line" dt_ip dt_p4 "")
    )
  )
)
;================================get_base=====================================

(defun get_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
    )
  )
)
;================================get_end_base=====================================

(defun get_end_base ()

  (setq x_list (cdadr x_list))
  (setq d_type (cdr (assoc 1000 x_list)))

  (cond
    ((= d_type "RND_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mds (cdr (nth 1 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
    ((= d_type "RECT_DUCT")
     (setq dp_mda (cdr (nth 0 x_list)))
     (setq dp_mdh (cdr (nth 1 x_list)))
     (setq dp_mds (cdr (nth 2 x_list)))
     (setq dp_e1  (cdr (assoc 1011 x_list)))
    )
  )
)
;================================eval_de=====================================

(defun eval_de ()
  (cond
    ((= de_pt "supply")
       (progn
         (setq vp_lyr sup_lyr)
         (setq cl_lyr scl_lyr)
         (setq tl_lyr stl_lyr)
	 (setq ac_lyr sac_lyr)
         (setq vp_clr sup_clr)
         (setq cl_clr scl_clr)
         (setq tl_clr stl_clr)
	 (setq ac_clr sac_clr)
       )
    )
    ((= de_pt "exhaust")
       (progn
         (setq vp_lyr exh_lyr)
         (setq cl_lyr ecl_lyr)
         (setq tl_lyr etl_lyr)
	 (setq ac_lyr eac_lyr)
         (setq vp_clr exh_clr)
         (setq cl_clr ecl_clr)
         (setq tl_clr etl_clr)
	 (setq ac_clr eac_clr)
       )
    )
  )
)
;==================================check_eval=====================================

(defun check_eval ()

  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" vp_lyr))) 0)
      (progn
        (setq vp_st  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rh  (assoc 70 vp_st))
        (setq vp_nch (cons 70 0))
        (setq vp_nst (subst vp_nch vp_rh vp_st))
        (entmod vp_nst)
      )
    )
  )
  
  (if (tblsearch "layer" vp_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" vp_lyr))) 7)
      (progn
        (setq vp_ft  (entget (tblobjname "layer" vp_lyr)))
        (setq vp_rf  (assoc 62 vp_ft))
        (setq vp_ncf (cons 62 7))
        (setq vp_fst (subst vp_ncf vp_rf vp_ft))
        (entmod vp_fst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" cl_lyr))) 0)
      (progn
        (setq cl_st  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rh  (assoc 70 cl_st))
        (setq cl_nch (cons 70 0))
        (setq cl_nst (subst cl_nch cl_rh cl_st))
        (entmod cl_nst)
      )
    )
  )

  (if (tblsearch "layer" cl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" cl_lyr))) 7)
      (progn
        (setq cl_ft  (entget (tblobjname "layer" cl_lyr)))
        (setq cl_rf  (assoc 62 cl_ft))
        (setq cl_ncf (cons 62 7))
        (setq cl_fst (subst cl_ncf cl_rf cl_ft))
        (entmod cl_fst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" tl_lyr))) 0)
      (progn
        (setq tl_st  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rh  (assoc 70 tl_st))
        (setq tl_nch (cons 70 0))
        (setq tl_nst (subst tl_nch tl_rh tl_st))
        (entmod tl_nst)
      )
    )
  )

  (if (tblsearch "layer" tl_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" tl_lyr))) 7)
      (progn
        (setq tl_ft  (entget (tblobjname "layer" tl_lyr)))
        (setq tl_rf  (assoc 62 tl_ft))
        (setq tl_ncf (cons 62 7))
        (setq tl_fst (subst tl_ncf tl_rf tl_ft))
        (entmod tl_fst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 70 (tblsearch "layer" ac_lyr))) 0)
      (progn
        (setq ac_st  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rh  (assoc 70 ac_st))
        (setq ac_nch (cons 70 0))
        (setq ac_nst (subst ac_nch ac_rh ac_st))
        (entmod ac_nst)
      )
    )
  )

  (if (tblsearch "layer" ac_lyr)
    (if (/= (cdr (assoc 62 (tblsearch "layer" ac_lyr))) 7)
      (progn
        (setq ac_ft  (entget (tblobjname "layer" ac_lyr)))
        (setq ac_rf  (assoc 62 ac_ft))
        (setq ac_ncf (cons 62 7))
        (setq ac_fst (subst ac_ncf ac_rf ac_ft))
        (entmod ac_fst)
      )
    )
  )
)
;;;=============================rest_de===================================

(Defun rest_dp ()

  (setq de_cfg (strcat (vl-filename-directory (findfile "delbow.lsp")) "\\" "delbow.cfg"))
  (if (= nil (findfile de_cfg))
    (progn
      (princ (strcat "\nCreating default layer settings..." "delbow.cfg\n"))
      (setq de_fh (open de_cfg "w"))
      (write-line "*** Configuration file for HVAC Duct program ***" de_fh)
      (write-line "Supply Air layer:" de_fh)
      (write-line "HVAC-SP" de_fh)
      (write-line "Supply Air layer color:" de_fh)
      (write-line "4" de_fh)
      (write-line "Supply Air Center Line layer:" de_fh)
      (write-line "HVAC-SP-CL" de_fh)
      (write-line "Supply Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Supply Air Text Line layer:" de_fh)
      (write-line "HVAC-SP-TL" de_fh)
      (write-line "Supply Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Supply Air Accessories layer:" de_fh)
      (write-line "HVAC-SP-AC" de_fh)
      (write-line "Supply Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "Exhaust Air layer:" de_fh)
      (write-line "HVAC-EX" de_fh)
      (write-line "Exhaust Air layer color:" de_fh)
      (write-line "6" de_fh)
      (write-line "Exhaust Air Center Line layer:" de_fh)
      (write-line "HVAC-EX-CL" de_fh)
      (write-line "Exhaust Air Center Line layer color:" de_fh)
      (write-line "1" de_fh)
      (write-line "Exhaust Air Text Line layer:" de_fh)
      (write-line "HVAC-EX-TL" de_fh)
      (write-line "Exhaust Air Text Line layer color:" de_fh)
      (write-line "2" de_fh)
      (write-line "Exhaust Air Accessories layer:" de_fh)
      (write-line "HVAC-EX-AC" de_fh)
      (write-line "Exhaust Air Accessories layer color:" de_fh)
      (write-line "3" de_fh)
      (write-line "End of File..." de_fh) 
      (close de_fh)
    )
  )
  (setq rd_cfg (open de_cfg "r"))
  (read-line rd_cfg) 
  (read-line rd_cfg) 
  (setq sup_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sup_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq scl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq scl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq stl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq stl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq sac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq sac_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq exh_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq exh_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq ecl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq ecl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq etl_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq etl_clr (atoi (read-line rd_cfg)))
  (read-line rd_cfg) 
  (setq eac_lyr (read-line rd_cfg))
  (read-line rd_cfg) 
  (setq eac_clr (atoi (read-line rd_cfg)))
  (close rd_cfg)
)
;;;=================================*error*======================================

(defun dt_err (s)

  (if (/= s "Function cancelled")
    (if (= s "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " s))
    )
  )
  (if dt_oer
    (setq *error* dt_oer)
  )
  (if plinewid_old (setvar "plinewid" plinewid_old))
  (if old_osnap    (setvar "osmode"   old_osnap))
  (if blipmode_old (setvar "blipmode" blipmode_old))
  (if pickbox_old  (setvar "pickbox"   pickbox_old))
  (if angbase_old  (setvar "angbase"  angbase_old))
  (if lay_old      (setvar "clayer"   lay_old))
  (if col_old      (setvar "cecolor"  col_old))
  (if celtype_old  (setvar "celtype"  celtype_old))
  (redraw)
  (command "_.undo" "end")
  (if old_cmdecho  (setvar "cmdecho"  old_cmdecho))
)
;;;;;;=================================*error*======================================

(princ)
  
  